/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ABOUT_H
#define ABOUT_H

#include <QtGui/QApplication>
#include <QtGui/QDialog>
#include <QPixmap>
#include <QBitmap>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>
#include <QtGui/QHBoxLayout>
#include <QMessageBox>
class AboutDlg: public QDialog
{
		Q_OBJECT
	public:
		AboutDlg ( QString ver = "", QWidget *parent = 0, Qt::WindowFlags f = Qt::Popup );
		~AboutDlg();
	private slots:
		void onQT();
	private:
		QVBoxLayout *verticalLayout;
		QHBoxLayout *horizontalLayout_2;
		QLabel *label;
		QLabel *label_2;
		QPushButton *pushButton;
		QPushButton *pushButton_2;
		QHBoxLayout *horizontalLayout;
		QSpacerItem *horizontalSpacer;
};

#endif
