/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ATTACH_H
#define ATTACH_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QLabel>
#include <QtGui/QListWidget>
#include <QtGui/QPushButton>
#include <QtGui/QSpinBox>
#include <QtGui/QWidget>
#include <QDir>
#include <QListWidget>
#include <QMessageBox>
#include <QDebug>

#include "Check_impl.h"

class Attach: public QDialog
{
		Q_OBJECT
	public:
		Attach ( QWidget* parent = 0, Qt::WindowFlags f = Qt::Dialog  , QString filename = "", int PageNUM = 0, QString bg = "" );
		~Attach();
		QStringList fileL;
		int *apage, *apageB, apageNUM;
	private slots:
		void SetPage ( int i );
		void on_OK();
		void onCAB();
		void on_Add();
		void on_Remove();
		void on_List ( QListWidgetItem * item );
	private:
		int Allpage;
		QString homeP;
		QListWidget *FilesList;
		QPushButton *add_button;
		QPushButton *remove_button;
		QGroupBox *groupBox;
		QWidget *layoutWidget;
		QGridLayout *gridLayout;
		QLabel *label;
		QLabel *nameLabel;
		QLabel *label_2;
		QLabel *pageLabel;
		QGroupBox *groupBox_2;
		QSpinBox *page_spin;
		QPushButton *CAB;
		QPushButton *OKB;
};

#endif
