/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef BURST_H
#define BURST_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QSpinBox>
#include <QtGui/QCheckBox>
#include <QtGui/QLineEdit>
#include <QtGui/QVBoxLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QWidget>
#include <QMessageBox>
#include <QInputDialog>
#include <QDebug>
#include <QRegExpValidator>

class Burst: public QDialog
{
		Q_OBJECT
	public:
		Burst ( QWidget* parent = 0, Qt::WindowFlags f = Qt::Dialog, QString bg = "" );
		~Burst();
		int zero;
		QString pref, pass;
	private slots:
		void on_Prefix();
		void on_Zero ( int i );
		void on_Help();
		void onOKB();
	private:
		QGroupBox *groupBox;
		QWidget *widget;
		QGridLayout *gridLayout;
		QLabel *label;
		QPushButton *pushButton;
		QLabel *label_2;
		QSpinBox *spinBox;
		QCheckBox *passCheck;
		QLineEdit *passEdit;
		QWidget *widget1;
		QVBoxLayout *verticalLayout;
		QHBoxLayout *horizontalLayout;
		QPushButton *OKB;
		QPushButton *HELPB;
		QPushButton *CAB;
};

#endif
