/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef DUMP_H
#define DUMP_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QTextBrowser>
#include <QtGui/QVBoxLayout>
#include <QFile>
#include <QTextStream>
#include <QFileInfo>
#include <QFileDialog>
class Dump: public QDialog
{
		Q_OBJECT
	public:
		Dump ( QWidget *parent, Qt::WindowFlags f );
		QString fileDump, pdfDump, formDump, fName;
		void INIT();
		void retranslateUi();
		~Dump();
	private slots:
		void onSave();

	private:
		QVBoxLayout *verticalLayout;
		QTextBrowser *textBrowser;
		QHBoxLayout *horizontalLayout;
		QPushButton *saveButton;
		QSpacerItem *horizontalSpacer;
		QPushButton *closeButton;
};

#endif
