/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*QString SuslicTk::getSaveFile()
{
	QString tmps = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
	return checkSaveFile ( tmps );
}*/
QString SuslicTk::checkSaveFile ( QString efile )
{
	if ( efile.isEmpty() ) return efile;
	QRegExp rx ( "(\\.|\\_|\\-|\\+|\\/|\\s|[A-Z]|[a-z]|[0-9])+" );
	if ( rx.exactMatch ( efile ) ) return efile;
	if ( showEFmes )
	{
		QMessageBox *msg = new QMessageBox ( this );
		//tr ( "Due to pdftk limitations, result cannot be saved as %1.<br>It will be saved in temporary directory and then copied to %1" ).arg ( efile )
		msg->setWindowTitle ( "PdfTk-QGUI" );
		msg->setText ( tr ( "Due to pdftk limitations, result cannot be saved as %1.<br>It will be saved in temporary directory and then copied to %1" ).arg ( efile ) );
		msg->setIcon ( QMessageBox::Information );
		QPushButton *showButton = msg->addButton ( tr ( "Do not show again" ), QMessageBox::ActionRole );
		QPushButton *okButton = msg->addButton ( QMessageBox::Ok );
		msg->exec();
		if ( msg->clickedButton() == showButton )	showEFmes = false;
	}
	int i=0;
	while ( QFile ( homePDF->absolutePath() +tr ( "/tmp_save_%1.pdf" ).arg ( i ) ).exists() ) i++;
	return ( homePDF->absolutePath() +tr ( "/tmp_save_%1.pdf" ).arg ( i ) );
}
bool SuslicTk::copyEFILE ( QString tmpFile, QString EFILE )
{
	if ( !QFile ( tmpFile ).exists() )  //should never happen
	{
		qDebug() <<"copyEFILE: "<<tmpFile<<" does not exist!!!";
	}
	if ( tmpFile == EFILE ) //should never happen
	{
		qDebug() <<"nothing to copy";
		return true;
	}
	if ( QFile ( EFILE ).exists() )
	{
		if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "Replace existing file %1?" ).arg ( EFILE ), QMessageBox::Yes|QMessageBox::No ) == QMessageBox::No )	return false;
		else	if ( !QFile ( EFILE ).remove() )
		{
			if ( QMessageBox::question ( this, "PdfTk-QGUI", tr ( "Failed to remove old file.\nDo you want to select another name?" ), QMessageBox::No|QMessageBox::Yes ) == QMessageBox::Yes )
			{
				QString efile1 = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), lastdir, tr ( "PDF Files (*.pdf)" ) );
				if ( efile1.isEmpty() ) return false;
				if ( !efile1.endsWith ( ".pdf", Qt::CaseInsensitive ) ) efile1+=".pdf";
				if ( !QFile::copy ( tmpFile, efile1 ) )
				{
					QMessageBox::warning ( this, "Oops...", tr ( "Unfortunately PdfTk-QGUI failed to copy temporary file %1 to %2. Temporary file won't be deleted until you close PdfTk-QGUI or select Edit->Delete tmp. So you can copy it manually " ).arg ( tmpFile ).arg ( efile1 ) );
				}
				else	QFile ( tmpFile ).remove();

			}
			return false;
		}
	}
	if ( !QFile::copy ( tmpFile, EFILE ) )
	{
		QMessageBox::warning ( this, "Oops...", tr ( "Unfortunately PdfTk-QGUI failed to copy temporary file %1 to %2. Temporary file won't be deleted until you close PdfTk-QGUI or select Edit->Delete tmp. So you can copy it manually " ).arg ( tmpFile ).arg ( EFILE ) );
		return false;
	}
	addTextTE ( tr ( "Copied %1 to %2" ).arg ( tmpFile ).arg ( EFILE ) );
	if ( QFile ( tmpFile ).remove() )	addTextTE ( tr ( "%1 removed" ).arg ( tmpFile ) );
	else	addTextTE ( tr ( "Failed to remove %1" ).arg ( tmpFile ) );
	return true;
}
