/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Encrypt.h"

Encrypt::Encrypt ( QWidget* parent, Qt::WindowFlags f, QString bg )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}

	this->setObjectName ( QString::fromUtf8 ( "Encrypt" ) );
	//this->setMinimumSize ( 342, 424 );
	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	groupBox->setGeometry ( QRect ( 10, 0, 321, 94 ) );
	//widget = new QWidget ( groupBox );
	//widget->setObjectName ( QString::fromUtf8 ( "widget" ) );
	//widget->setGeometry ( QRect ( 10, 20, 301, 54 ) );
	gridLayout = new QGridLayout ( groupBox );
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );
	gridLayout->setContentsMargins ( 0, 0, 0, 0 );
	userCheck = new QCheckBox ( groupBox );
	userCheck->setObjectName ( QString::fromUtf8 ( "userCheck" ) );

	gridLayout->addWidget ( userCheck, 0, 0, 1, 1 );

	QRegExpValidator *regV = new QRegExpValidator(QRegExp("([^\"])+"), this);
	userEdit = new QLineEdit ( groupBox );
	userEdit->setObjectName ( QString::fromUtf8 ( "userEdit" ) );
	userEdit->setValidator(regV);
	gridLayout->addWidget ( userEdit, 0, 1, 1, 1 );

	ownerCheck = new QCheckBox ( groupBox );
	ownerCheck->setObjectName ( QString::fromUtf8 ( "ownerCheck" ) );

	gridLayout->addWidget ( ownerCheck, 1, 0, 1, 1 );

	ownerEdit = new QLineEdit ( groupBox );
	ownerEdit->setObjectName ( QString::fromUtf8 ( "ownerEdit" ) );
	ownerEdit->setValidator(regV);

	gridLayout->addWidget ( ownerEdit, 1, 1, 1, 1 );

	groupBox_2 = new QGroupBox ( this );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	//groupBox_2->setGeometry ( QRect ( 10, 100, 321, 61 ) );
	//widget1 = new QWidget ( groupBox_2 );
	//widget1->setObjectName ( QString::fromUtf8 ( "widget1" ) );
	//widget1->setGeometry ( QRect ( 20, 20, 291, 24 ) );
	horizontalLayout = new QHBoxLayout ( groupBox_2 );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	horizontalLayout->setContentsMargins ( 0, 0, 0, 0 );
	radio40 = new QRadioButton ( groupBox_2 );
	radio40->setObjectName ( QString::fromUtf8 ( "radio40" ) );

	horizontalLayout->addWidget ( radio40 );

	radio128 = new QRadioButton ( groupBox_2 );
	radio128->setObjectName ( QString::fromUtf8 ( "radio128" ) );

	horizontalLayout->addWidget ( radio128 );

	groupBox_3 = new QGroupBox ( this );
	groupBox_3->setObjectName ( QString::fromUtf8 ( "groupBox_3" ) );

	featureGroupbox = new QGroupBox ( groupBox_3 );
	featureGroupbox->setObjectName ( QString::fromUtf8 ( "featureGroupbox" ) );

	gridLayout_2 = new QGridLayout ( featureGroupbox );
	gridLayout_2->setObjectName ( QString::fromUtf8 ( "gridLayout_2" ) );
	gridLayout_2->setContentsMargins ( 0, 0, 0, 0 );
	Printing = new QCheckBox ( featureGroupbox );
	Printing->setObjectName ( QString::fromUtf8 ( "Printing" ) );

	gridLayout_2->addWidget ( Printing, 0, 0, 1, 1 );

	CopyContents = new QCheckBox ( featureGroupbox );
	CopyContents->setObjectName ( QString::fromUtf8 ( "CopyContents" ) );

	gridLayout_2->addWidget ( CopyContents, 0, 1, 1, 1 );

	DegradedPrinting = new QCheckBox ( featureGroupbox );
	DegradedPrinting->setObjectName ( QString::fromUtf8 ( "DegradedPrinting" ) );

	gridLayout_2->addWidget ( DegradedPrinting, 1, 0, 1, 1 );

	ScreenReaders = new QCheckBox ( featureGroupbox );
	ScreenReaders->setObjectName ( QString::fromUtf8 ( "ScreenReaders" ) );

	gridLayout_2->addWidget ( ScreenReaders, 1, 1, 1, 1 );

	ModifyContents = new QCheckBox ( featureGroupbox );
	ModifyContents->setObjectName ( QString::fromUtf8 ( "ModifyContents" ) );

	gridLayout_2->addWidget ( ModifyContents, 2, 0, 1, 1 );

	ModifyAnnotations = new QCheckBox ( featureGroupbox );
	ModifyAnnotations->setObjectName ( QString::fromUtf8 ( "ModifyAnnotations" ) );

	gridLayout_2->addWidget ( ModifyAnnotations, 2, 1, 1, 1 );

	Assembly = new QCheckBox ( featureGroupbox );
	Assembly->setObjectName ( QString::fromUtf8 ( "Assembly" ) );

	gridLayout_2->addWidget ( Assembly, 3, 0, 1, 1 );

	FillIn = new QCheckBox ( featureGroupbox );
	FillIn->setObjectName ( QString::fromUtf8 ( "FillIn" ) );

	gridLayout_2->addWidget ( FillIn, 3, 1, 1, 1 );

	widget3 = new QWidget ( groupBox_3 );
	widget3->setObjectName ( QString::fromUtf8 ( "widget3" ) );
	//widget3->setGeometry ( QRect ( 10, 20, 301, 24 ) );
	horizontalLayout_2 = new QHBoxLayout ( widget3 );
	horizontalLayout_2->setObjectName ( QString::fromUtf8 ( "horizontalLayout_2" ) );
	horizontalLayout_2->setContentsMargins ( 0, 0, 0, 0 );
	allRadio = new QRadioButton ( widget3 );
	allRadio->setObjectName ( QString::fromUtf8 ( "allRadio" ) );
	allRadio->setChecked ( true );
	horizontalLayout_2->addWidget ( allRadio );

	selRadio = new QRadioButton ( widget3 );
	selRadio->setObjectName ( QString::fromUtf8 ( "selRadio" ) );

	horizontalLayout_2->addWidget ( selRadio );

	verticalLayout = new QVBoxLayout ( groupBox_3 );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	verticalLayout->setContentsMargins ( 0, 0, 0, 0 );
	verticalLayout->addWidget ( widget3 );
	verticalLayout->addWidget ( featureGroupbox );

	widget4 = new QWidget ( this );
	widget4->setObjectName ( QString::fromUtf8 ( "widget4" ) );
	//widget4->setGeometry ( QRect ( 170, 390, 162, 31 ) );
	horizontalLayout_3 = new QHBoxLayout ( widget4 );
	horizontalLayout_3->setObjectName ( QString::fromUtf8 ( "horizontalLayout_3" ) );
	horizontalLayout_3->setContentsMargins ( 0, 0, 0, 0 );

	horizontalSpacer = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout_3->addItem ( horizontalSpacer );

	CAB = new QPushButton ( widget4 );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout_3->addWidget ( CAB );

	OKB = new QPushButton ( widget4 );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout_3->addWidget ( OKB );

	allLayout = new QVBoxLayout ( this );
	allLayout->setObjectName ( QString::fromUtf8 ( "allLayout" ) );
	allLayout->setContentsMargins ( 0, 0, 0, 0 );
	allLayout->addWidget ( groupBox );
	allLayout->addWidget ( groupBox_2 );
	allLayout->addWidget ( groupBox_3 );
	allLayout->addWidget ( widget4 );
	adjustSize();

	this->setWindowTitle ( QApplication::translate ( "Encrypt", "Encrypt", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "Encrypt", "Encryption:", 0, QApplication::UnicodeUTF8 ) );
	userCheck->setText ( QApplication::translate ( "Encrypt", "User Password", 0, QApplication::UnicodeUTF8 ) );
	ownerCheck->setText ( QApplication::translate ( "Encrypt", "Owner Password", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setTitle ( QApplication::translate ( "Encrypt", "Encryption method:", 0, QApplication::UnicodeUTF8 ) );
	radio40->setText ( QApplication::translate ( "Encrypt", "40 bit", 0, QApplication::UnicodeUTF8 ) );
	radio128->setText ( QApplication::translate ( "Encrypt", "128 bit", 0, QApplication::UnicodeUTF8 ) );
	groupBox_3->setTitle ( QApplication::translate ( "Encrypt", "Permissions:", 0, QApplication::UnicodeUTF8 ) );
	featureGroupbox->setTitle ( QApplication::translate ( "Encrypt", "Available features:", 0, QApplication::UnicodeUTF8 ) );
	Printing->setText ( QApplication::translate ( "Encrypt", "Printing (HQ)", 0, QApplication::UnicodeUTF8 ) );
	Printing->setToolTip ( tr ( "Allows High Quality Printing" ) );
	CopyContents->setText ( QApplication::translate ( "Encrypt", "Copy Contents", 0, QApplication::UnicodeUTF8 ) );
	DegradedPrinting->setText ( QApplication::translate ( "Encrypt", "Printing (LQ)", 0, QApplication::UnicodeUTF8 ) );
	DegradedPrinting->setToolTip ( tr ( "Allows Low Quality Printing" ) );
	ScreenReaders->setText ( QApplication::translate ( "Encrypt", "Screen Readers", 0, QApplication::UnicodeUTF8 ) );
	ModifyContents->setText ( QApplication::translate ( "Encrypt", "Modify Contents", 0, QApplication::UnicodeUTF8 ) );
	ModifyAnnotations->setText ( QApplication::translate ( "Encrypt", "Annotations", 0, QApplication::UnicodeUTF8 ) );
	Assembly->setText ( QApplication::translate ( "Encrypt", "Assembly", 0, QApplication::UnicodeUTF8 ) );
	FillIn->setText ( QApplication::translate ( "Encrypt", "Fill In", 0, QApplication::UnicodeUTF8 ) );
	allRadio->setText ( QApplication::translate ( "Encrypt", "All features", 0, QApplication::UnicodeUTF8 ) );
	selRadio->setText ( QApplication::translate ( "Encrypt", "Selected", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "Encrypt", "Cancel", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "Encrypt", "OK", 0, QApplication::UnicodeUTF8 ) );
//////////////////////////////////////////////
	featureGroupbox->setVisible ( false );
	setWindowIcon ( QIcon ( ":/encr" ) );
	OKB->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DialogOkButton) ) );
	if ( !bg.isEmpty() ) {setStyleSheet ( tr ( "QDialog{background: url(%1);}" ).arg ( bg ) );}
	result = "";
	opa = "";upa = "";encrt = "_128bit";
	radio128->setChecked ( true );
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( onOK() ) );
	connect ( userCheck, SIGNAL ( clicked ( bool ) ), this, SLOT ( onUser ( bool ) ) );
	connect ( ownerCheck, SIGNAL ( clicked ( bool ) ), this, SLOT ( onOwner ( bool ) ) );
	connect ( allRadio, SIGNAL ( clicked ( bool ) ), this, SLOT ( onAllRadio ( bool ) ) );
	connect ( selRadio, SIGNAL ( clicked ( bool ) ), this, SLOT ( onSelRadio ( bool ) ) );
	connect ( radio40, SIGNAL ( clicked ( bool ) ), this, SLOT ( on40 ( bool ) ) );
	connect ( radio128, SIGNAL ( clicked ( bool ) ), this, SLOT ( on128 ( bool ) ) );
	connect ( userEdit, SIGNAL ( textChanged ( QString ) ), this, SLOT ( onUserEdit ( QString ) ) );
	connect ( ownerEdit, SIGNAL ( textChanged ( QString ) ), this, SLOT ( onOwnerEdit ( QString ) ) );
	ownerEdit->setEnabled ( false );
	userEdit->setEnabled ( false );
//////////////////////////////////////////////
}
void Encrypt::keyPressEvent ( QKeyEvent *e )
{
	if ( e->key() == Qt::Key_O ) {onOK();}
	if ( e->key() == Qt::Key_Escape ) {reject();}
}
void Encrypt::onUser ( bool check )
{
	userEdit->setEnabled ( check );
	if ( check ) {userEdit->selectAll();userEdit->setFocus();}
}
void Encrypt::onOwner ( bool check )
{
	ownerEdit->setEnabled ( check );
	if ( check ) {ownerEdit->selectAll();ownerEdit->setFocus();}
}
void Encrypt::onUserEdit ( QString str ) { userCheck->setChecked ( true );upa = str;}
void Encrypt::onOwnerEdit ( QString str ) { ownerCheck->setChecked ( true );opa = str;}
void Encrypt::on40 ( bool check ) {if ( check ) {encrt = "_40bit";}}
void Encrypt::on128 ( bool check ) {if ( check ) {encrt = "_128bit";}}
void Encrypt::onAllRadio ( bool check )
{
	if ( check )
	{
		featureGroupbox->setVisible ( false );
		adjustSize();
	}
}
void Encrypt::onSelRadio ( bool check )
{
	if ( check )
	{
		featureGroupbox->setVisible ( true );
		adjustSize();
	}
}
void Encrypt::onOK()
{
	if ( ownerCheck->isChecked() && userCheck->isChecked() && opa == upa )
	{
		QMessageBox::warning ( this, "", tr ( "Error: The user and owner passwords are the same. PDF Viewers interpret this to mean your PDF has no owner password, so they must be different. Alternatively, supply no owner password to pdftk if this is what you desire." ) );
	}
	else
	{
		if ( userCheck->isChecked() || ownerCheck->isChecked() )
		{
			result = "encrypt"+encrt;//" allow ";
			if ( ownerCheck->isChecked() ) result+=" owner_pw \""+opa+"\" ";
			if ( userCheck->isChecked() ) result+=" user_pw \""+upa+"\" ";
			result+=" allow ";
			if ( allRadio->isChecked() ) {result+="AllFeatures";}
			else
			{
				if ( Printing->isChecked() ) {result+="Printing ";}
				if ( CopyContents->isChecked() ) {result+="CopyContents ";}
				if ( DegradedPrinting->isChecked() ) {result+="DegradedPrinting ";}
				if ( ScreenReaders->isChecked() ) {result+="ScreenReaders ";}
				if ( ModifyContents->isChecked() ) {result+="ModifyContents ";}
				if ( ModifyAnnotations->isChecked() ) {result+="ModifyAnnotations ";}
				if ( Assembly->isChecked() ) {result+="Assembly ";}
				if ( FillIn->isChecked() ) {result+="FillIn ";}
			}
		}
		accept();
	}
}
Encrypt::~Encrypt()
{
	destroy();
}
