/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "PrefsDlg.h"
#include "PrefsDlg_readSettings.h"

//#include <iostream>
//using namespace std;

PrefsDlg::PrefsDlg ( QWidget* parent, Qt::WindowFlags f, QString ver )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	vers = ver;
	clipb = QApplication::clipboard();
	///////////////////////////////////////////
	this->setObjectName ( QString::fromUtf8 ( "PrefsDlg" ) );
	this->setFixedSize ( 646, 589 );
	tabWidget = new QTabWidget ( this );
	tabWidget->setObjectName ( QString::fromUtf8 ( "tabWidget" ) );
	tabWidget->setGeometry ( QRect ( 10, 160, 631, 421 ) );
	intSE = new QWidget();
	intSE->setObjectName ( QString::fromUtf8 ( "intSE" ) );
	groupBox_2 = new QGroupBox ( intSE );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	groupBox_2->setGeometry ( QRect ( 10, 230, 601, 141 ) );
	layoutWidget = new QWidget ( groupBox_2 );
	layoutWidget->setObjectName ( QString::fromUtf8 ( "layoutWidget" ) );
	layoutWidget->setGeometry ( QRect ( 10, 20, 581, 109 ) );
	horizontalLayout_7 = new QHBoxLayout ( layoutWidget );
	horizontalLayout_7->setObjectName ( QString::fromUtf8 ( "horizontalLayout_7" ) );
	horizontalLayout_7->setContentsMargins ( 0, 0, 0, 0 );
	backList = new QListWidget ( layoutWidget );
	backList->setObjectName ( QString::fromUtf8 ( "backList" ) );

	horizontalLayout_7->addWidget ( backList );

	verticalLayout = new QVBoxLayout();
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	addButton = new QPushButton ( layoutWidget );
	addButton->setObjectName ( QString::fromUtf8 ( "addButton" ) );

	verticalLayout->addWidget ( addButton );

	remButton = new QPushButton ( layoutWidget );
	remButton->setObjectName ( QString::fromUtf8 ( "remButton" ) );

	verticalLayout->addWidget ( remButton );

	saveButton = new QPushButton ( layoutWidget );
	saveButton->setObjectName ( QString::fromUtf8 ( "saveButton" ) );

	verticalLayout->addWidget ( saveButton );


	horizontalLayout_7->addLayout ( verticalLayout );

	textGroupBox = new QGroupBox ( intSE );
	textGroupBox->setObjectName ( QString::fromUtf8 ( "textGroupBox" ) );
	textGroupBox->setGeometry ( QRect ( 10, 10, 321, 151 ) );
	layoutWidget1 = new QWidget ( textGroupBox );
	layoutWidget1->setObjectName ( QString::fromUtf8 ( "layoutWidget1" ) );
	layoutWidget1->setGeometry ( QRect ( 20, 20, 282, 111 ) );
	gridLayout_2 = new QGridLayout ( layoutWidget1 );
	gridLayout_2->setObjectName ( QString::fromUtf8 ( "gridLayout_2" ) );
	gridLayout_2->setContentsMargins ( 0, 0, 0, 0 );
	textLabel = new QLabel ( layoutWidget1 );
	textLabel->setObjectName ( QString::fromUtf8 ( "textLabel" ) );

	gridLayout_2->addWidget ( textLabel, 0, 0, 1, 1 );

	horizontalLayout_6 = new QHBoxLayout();
	horizontalLayout_6->setObjectName ( QString::fromUtf8 ( "horizontalLayout_6" ) );
	colorEdit = new QLineEdit ( layoutWidget1 );
	colorEdit->setObjectName ( QString::fromUtf8 ( "colorEdit" ) );

	horizontalLayout_6->addWidget ( colorEdit );

	colorButton = new QPushButton ( layoutWidget1 );
	colorButton->setObjectName ( QString::fromUtf8 ( "colorButton" ) );

	horizontalLayout_6->addWidget ( colorButton );


	gridLayout_2->addLayout ( horizontalLayout_6, 0, 1, 1, 1 );

	label_3 = new QLabel ( layoutWidget1 );
	label_3->setObjectName ( QString::fromUtf8 ( "label_3" ) );

	gridLayout_2->addWidget ( label_3, 1, 0, 1, 1 );

	fontCombo = new QFontComboBox ( layoutWidget1 );
	fontCombo->setObjectName ( QString::fromUtf8 ( "fontCombo" ) );

	gridLayout_2->addWidget ( fontCombo, 1, 1, 1, 1 );

	label_4 = new QLabel ( layoutWidget1 );
	label_4->setObjectName ( QString::fromUtf8 ( "label_4" ) );

	gridLayout_2->addWidget ( label_4, 2, 0, 1, 1 );

	horizontalLayout_2 = new QHBoxLayout();
	horizontalLayout_2->setObjectName ( QString::fromUtf8 ( "horizontalLayout_2" ) );
	fontSpin = new QSpinBox ( layoutWidget1 );
	fontSpin->setObjectName ( QString::fromUtf8 ( "fontSpin" ) );

	horizontalLayout_2->addWidget ( fontSpin );

	horizontalSpacer = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout_2->addItem ( horizontalSpacer );


	gridLayout_2->addLayout ( horizontalLayout_2, 2, 1, 1, 1 );

	groupBox = new QGroupBox ( intSE );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	groupBox->setGeometry ( QRect ( 370, 10, 221, 151 ) );
	layoutWidget2 = new QWidget ( groupBox );
	layoutWidget2->setObjectName ( QString::fromUtf8 ( "layoutWidget2" ) );
	layoutWidget2->setGeometry ( QRect ( 10, 40, 201, 81 ) );
	gridLayout_3 = new QGridLayout ( layoutWidget2 );
	gridLayout_3->setObjectName ( QString::fromUtf8 ( "gridLayout_3" ) );
	gridLayout_3->setContentsMargins ( 0, 0, 0, 0 );
	bgSelect = new QLabel ( layoutWidget2 );
	bgSelect->setObjectName ( QString::fromUtf8 ( "bgSelect" ) );

	gridLayout_3->addWidget ( bgSelect, 0, 0, 1, 1 );

	horizontalLayout_4 = new QHBoxLayout();
	horizontalLayout_4->setObjectName ( QString::fromUtf8 ( "horizontalLayout_4" ) );
	colRadio = new QRadioButton ( layoutWidget2 );
	colRadio->setObjectName ( QString::fromUtf8 ( "colRadio" ) );

	horizontalLayout_4->addWidget ( colRadio );

	imgRadio = new QRadioButton ( layoutWidget2 );
	imgRadio->setObjectName ( QString::fromUtf8 ( "imgRadio" ) );

	horizontalLayout_4->addWidget ( imgRadio );


	gridLayout_3->addLayout ( horizontalLayout_4, 0, 1, 1, 2 );

	bgLabel = new QLabel ( layoutWidget2 );
	bgLabel->setObjectName ( QString::fromUtf8 ( "bgLabel" ) );

	gridLayout_3->addWidget ( bgLabel, 1, 0, 1, 2 );

	horizontalLayout_3 = new QHBoxLayout();
	horizontalLayout_3->setObjectName ( QString::fromUtf8 ( "horizontalLayout_3" ) );
	backEdit = new QLineEdit ( layoutWidget2 );
	backEdit->setObjectName ( QString::fromUtf8 ( "backEdit" ) );

	horizontalLayout_3->addWidget ( backEdit );

	backButton = new QPushButton ( layoutWidget2 );
	backButton->setObjectName ( QString::fromUtf8 ( "backButton" ) );

	horizontalLayout_3->addWidget ( backButton );


	gridLayout_3->addLayout ( horizontalLayout_3, 1, 2, 1, 1 );

	tabWidget->addTab ( intSE, QString() );
	extSE = new QWidget();
	extSE->setObjectName ( QString::fromUtf8 ( "extSE" ) );
	cssEdit = new QTextEdit ( extSE );
	cssEdit->setObjectName ( QString::fromUtf8 ( "cssEdit" ) );
	cssEdit->setGeometry ( QRect ( 10, 10, 601, 331 ) );
	layoutWidget3 = new QWidget ( extSE );
	layoutWidget3->setObjectName ( QString::fromUtf8 ( "layoutWidget3" ) );
	layoutWidget3->setGeometry ( QRect ( 11, 350, 601, 29 ) );
	horizontalLayout_8 = new QHBoxLayout ( layoutWidget3 );
	horizontalLayout_8->setObjectName ( QString::fromUtf8 ( "horizontalLayout_8" ) );
	horizontalLayout_8->setContentsMargins ( 0, 0, 0, 0 );
	copyTool = new QToolButton ( layoutWidget3 );
	copyTool->setObjectName ( QString::fromUtf8 ( "copyTool" ) );

	horizontalLayout_8->addWidget ( copyTool );

	pasteTool = new QToolButton ( layoutWidget3 );
	pasteTool->setObjectName ( QString::fromUtf8 ( "pasteTool" ) );

	horizontalLayout_8->addWidget ( pasteTool );

	cutTool = new QToolButton ( layoutWidget3 );
	cutTool->setObjectName ( QString::fromUtf8 ( "cutTool" ) );

	horizontalLayout_8->addWidget ( cutTool );

	undoTool = new QToolButton ( layoutWidget3 );
	undoTool->setObjectName ( QString::fromUtf8 ( "undoTool" ) );

	horizontalLayout_8->addWidget ( undoTool );

	redoTool = new QToolButton ( layoutWidget3 );
	redoTool->setObjectName ( QString::fromUtf8 ( "redoTool" ) );

	horizontalLayout_8->addWidget ( redoTool );

	horizontalSpacer_2 = new QSpacerItem ( 148, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout_8->addItem ( horizontalSpacer_2 );

	previewButton = new QPushButton ( layoutWidget3 );
	previewButton->setObjectName ( QString::fromUtf8 ( "previewButton" ) );

	horizontalLayout_8->addWidget ( previewButton );

	testColor = new QPushButton ( layoutWidget3 );
	testColor->setObjectName ( QString::fromUtf8 ( "testColor" ) );

	horizontalLayout_8->addWidget ( testColor );

	saveCSSButton = new QPushButton ( layoutWidget3 );
	saveCSSButton->setObjectName ( QString::fromUtf8 ( "saveCSSButton" ) );

	horizontalLayout_8->addWidget ( saveCSSButton );

	tabWidget->addTab ( extSE, QString() );
////////////
	printerSet = new QWidget();
	printerSet->setObjectName ( QString::fromUtf8 ( "printerSet" ) );
	layoutWidget6 = new QWidget ( printerSet );
	layoutWidget6->setObjectName ( QString::fromUtf8 ( "layoutWidget6" ) );
	layoutWidget6->setGeometry ( QRect ( 30, 30, 521, 321 ) );
	gridLayout_5 = new QGridLayout ( layoutWidget6 );
	gridLayout_5->setObjectName ( QString::fromUtf8 ( "gridLayout_5" ) );
	gridLayout_5->setContentsMargins ( 0, 0, 0, 0 );
	orientLabel = new QLabel ( layoutWidget6 );
	orientLabel->setObjectName ( QString::fromUtf8 ( "orientLabel" ) );

	gridLayout_5->addWidget ( orientLabel, 0, 0, 1, 1 );

	orientCombo = new QComboBox ( layoutWidget6 );
	orientCombo->setObjectName ( QString::fromUtf8 ( "orientCombo" ) );

	gridLayout_5->addWidget ( orientCombo, 0, 1, 1, 1 );

	resolLabel = new QLabel ( layoutWidget6 );
	resolLabel->setObjectName ( QString::fromUtf8 ( "resolLabel" ) );

	gridLayout_5->addWidget ( resolLabel, 1, 0, 1, 1 );

	resolSpin = new QSpinBox ( layoutWidget6 );
	resolSpin->setObjectName ( QString::fromUtf8 ( "resolSpin" ) );
	resolSpin->setMinimum ( 100 );
	resolSpin->setMaximum ( 1200 );
	resolSpin->setSingleStep ( 10 );

	gridLayout_5->addWidget ( resolSpin, 1, 1, 1, 1 );

	colorMLabel = new QLabel ( layoutWidget6 );
	colorMLabel->setObjectName ( QString::fromUtf8 ( "colorMLabel" ) );

	gridLayout_5->addWidget ( colorMLabel, 2, 0, 1, 1 );

	colorMCombo = new QComboBox ( layoutWidget6 );
	colorMCombo->setObjectName ( QString::fromUtf8 ( "colorMCombo" ) );

	gridLayout_5->addWidget ( colorMCombo, 2, 1, 1, 1 );

	orderLabel = new QLabel ( layoutWidget6 );
	orderLabel->setObjectName ( QString::fromUtf8 ( "orderLabel" ) );

	gridLayout_5->addWidget ( orderLabel, 3, 0, 1, 1 );

	orderCombo = new QComboBox ( layoutWidget6 );
	orderCombo->setObjectName ( QString::fromUtf8 ( "orderCombo" ) );

	gridLayout_5->addWidget ( orderCombo, 3, 1, 1, 1 );

	tabWidget->addTab ( printerSet, QString() );
////////////////

////////////////
	scriptTab = new QWidget();
	scriptTab->setObjectName ( QString::fromUtf8 ( "scriptTab" ) );
	verticalLayout_10 = new QVBoxLayout ( scriptTab );
	verticalLayout_10->setObjectName ( QString::fromUtf8 ( "verticalLayout_10" ) );
	horizontalLayout_10 = new QHBoxLayout();
	horizontalLayout_10->setObjectName ( QString::fromUtf8 ( "horizontalLayout_10" ) );
	label_10 = new QLabel ( scriptTab );
	label_10->setObjectName ( QString::fromUtf8 ( "label_10" ) );

	horizontalLayout_10->addWidget ( label_10 );

	favSpin = new QSpinBox ( scriptTab );
	favSpin->setObjectName ( QString::fromUtf8 ( "favSpin" ) );
	favSpin->setButtonSymbols ( QAbstractSpinBox::UpDownArrows );
	favSpin->setMaximum ( 5 );

	horizontalLayout_10->addWidget ( favSpin );


	verticalLayout_10->addLayout ( horizontalLayout_10 );

	askdirBox = new QCheckBox ( scriptTab );
	askdirBox->setObjectName ( QString::fromUtf8 ( "askdirBox" ) );

	verticalLayout_10->addWidget ( askdirBox );

	favScriptBox = new QGroupBox ( scriptTab );
	favScriptBox->setObjectName ( QString::fromUtf8 ( "favScriptBox" ) );
	verticalLayout_11 = new QVBoxLayout ( favScriptBox );
	verticalLayout_11->setObjectName ( QString::fromUtf8 ( "verticalLayout_11" ) );
	gridLayout_10 = new QGridLayout();
	gridLayout_10->setObjectName ( QString::fromUtf8 ( "gridLayout_10" ) );

	favCombos = new QComboBox*[5];
	favLabels = new QLabel*[5];
	for ( int i=0;i<5;i++ )
	{
		favLabels[i] = new QLabel ( favScriptBox );
		favLabels[i]->setObjectName ( tr ( "favLabel_%1" ).arg ( i ) );
		favLabels[i]->setAlignment ( Qt::AlignCenter );
		favLabels[i]->setText ( QApplication::translate ( "PrefsDlg", "Script %1:", 0, QApplication::UnicodeUTF8 ).arg ( i+1 ) );
		gridLayout_10->addWidget ( favLabels[i], i, 0, 1, 1 );

		favCombos[i] = new QComboBox ( favScriptBox );
		favCombos[i]->setObjectName ( tr ( "favCombo_%1" ).arg ( i ) );
		gridLayout_10->addWidget ( favCombos[i], i, 1, 1, 1 );
	}

	verticalLayout_11->addLayout ( gridLayout_10 );

	verticalLayout_10->addWidget ( favScriptBox );

	tabWidget->addTab ( scriptTab, QString() );

////////////////
	layoutWidget4 = new QWidget ( this );
	layoutWidget4->setObjectName ( QString::fromUtf8 ( "layoutWidget4" ) );
	layoutWidget4->setGeometry ( QRect ( 11, 11, 431, 139 ) );
	verticalLayout_2 = new QVBoxLayout ( layoutWidget4 );
	verticalLayout_2->setObjectName ( QString::fromUtf8 ( "verticalLayout_2" ) );
	verticalLayout_2->setContentsMargins ( 0, 0, 0, 0 );
	gridLayout = new QGridLayout();
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );
	
	label = new QLabel ( layoutWidget4 );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	gridLayout->addWidget ( label, 0, 0, 1, 1 );
	
	viewerEdit = new QComboBox ( layoutWidget4 );
	viewerEdit->setObjectName ( QString::fromUtf8 ( "viewerEdit" ) );

	gridLayout->addWidget ( viewerEdit, 0, 1, 1, 1 );

	label_2 = new QLabel ( layoutWidget4 );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );

	gridLayout->addWidget ( label_2, 1, 0, 1, 1 );

	pdftkEdit = new QLineEdit ( layoutWidget4 );
	pdftkEdit->setObjectName ( QString::fromUtf8 ( "pdftkEdit" ) );

	gridLayout->addWidget ( pdftkEdit, 1, 1, 1, 1 );

	pdftkTick = new QLabel ( layoutWidget4 );
	pdftkTick->setObjectName ( QString::fromUtf8 ( "pdftkTick" ) );

	gridLayout->addWidget ( pdftkTick, 1, 2, 1, 1 );

	searchViewer = new QToolButton ( layoutWidget4 );
	searchViewer->setObjectName ( QString::fromUtf8 ( "searchViewer" ) );

	gridLayout->addWidget ( searchViewer, 0, 3, 1, 1 );

	searchTK = new QToolButton ( layoutWidget4 );
	searchTK->setObjectName ( QString::fromUtf8 ( "searchTK" ) );

	gridLayout->addWidget ( searchTK, 1, 3, 1, 1 );


	verticalLayout_2->addLayout ( gridLayout );

	horizontalLayout_5 = new QHBoxLayout();
	horizontalLayout_5->setObjectName ( QString::fromUtf8 ( "horizontalLayout_5" ) );
	lfLabel = new QLabel ( layoutWidget4 );
	lfLabel->setObjectName ( QString::fromUtf8 ( "lfLabel" ) );

	horizontalLayout_5->addWidget ( lfLabel );

	StyleCombo = new QComboBox ( layoutWidget4 );
	StyleCombo->setObjectName ( QString::fromUtf8 ( "StyleCombo" ) );

	horizontalLayout_5->addWidget ( StyleCombo );


	verticalLayout_2->addLayout ( horizontalLayout_5 );

	horizontalLayout = new QHBoxLayout();
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	cssCheckBox = new QCheckBox ( layoutWidget4 );
	cssCheckBox->setObjectName ( QString::fromUtf8 ( "cssCheckBox" ) );

	horizontalLayout->addWidget ( cssCheckBox );

	cssButton = new QPushButton ( layoutWidget4 );
	cssButton->setObjectName ( QString::fromUtf8 ( "cssButton" ) );

	horizontalLayout->addWidget ( cssButton );


	verticalLayout_2->addLayout ( horizontalLayout );

	langGroup = new QGroupBox ( this );
	langGroup->setObjectName ( QString::fromUtf8 ( "langGroup" ) );
	langGroup->setGeometry ( QRect ( 450, 10, 181, 61 ) );
	langCombo = new QComboBox ( langGroup );
	langCombo->setObjectName ( QString::fromUtf8 ( "langCombo" ) );
	langCombo->setGeometry ( QRect ( 8, 20, 164, 24 ) );
	layoutWidget5 = new QWidget ( this );
	layoutWidget5->setObjectName ( QString::fromUtf8 ( "layoutWidget5" ) );
	layoutWidget5->setGeometry ( QRect ( 460, 120, 166, 29 ) );
	horizontalLayout_9 = new QHBoxLayout ( layoutWidget5 );
	horizontalLayout_9->setObjectName ( QString::fromUtf8 ( "horizontalLayout_9" ) );
	horizontalLayout_9->setContentsMargins ( 0, 0, 0, 0 );
	CAB = new QPushButton ( layoutWidget5 );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout_9->addWidget ( CAB );

	OKB = new QPushButton ( layoutWidget5 );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout_9->addWidget ( OKB );


#ifndef QT_NO_SHORTCUT
	textLabel->setBuddy ( colorEdit );
	label_3->setBuddy ( fontCombo );
	label_4->setBuddy ( fontSpin );
	bgLabel->setBuddy ( backEdit );
	label_2->setBuddy ( pdftkEdit );
	label->setBuddy ( viewerEdit );
	lfLabel->setBuddy ( StyleCombo );
#endif // QT_NO_SHORTCUT

	this->setWindowTitle ( QApplication::translate ( "PrefsDlg", "Preferences", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setTitle ( QApplication::translate ( "PrefsDlg", "Image database:", 0, QApplication::UnicodeUTF8 ) );
	addButton->setText ( QApplication::translate ( "PrefsDlg", "&Add Image", 0, QApplication::UnicodeUTF8 ) );
	remButton->setText ( QApplication::translate ( "PrefsDlg", "&Remove", 0, QApplication::UnicodeUTF8 ) );
	saveButton->setText ( QApplication::translate ( "PrefsDlg", "&Save", 0, QApplication::UnicodeUTF8 ) );
	textGroupBox->setTitle ( QApplication::translate ( "PrefsDlg", "Text properties:", 0, QApplication::UnicodeUTF8 ) );

#ifndef QT_NO_TOOLTIP
	textLabel->setToolTip ( QApplication::translate ( "PrefsDlg", "Report field text color", 0, QApplication::UnicodeUTF8 ) );
#endif // QT_NO_TOOLTIP

	textLabel->setText ( QApplication::translate ( "PrefsDlg", "&Text color:", 0, QApplication::UnicodeUTF8 ) );
	colorButton->setText ( QString() );
	label_3->setText ( QApplication::translate ( "PrefsDlg", "&Font:", 0, QApplication::UnicodeUTF8 ) );
	label_4->setText ( QApplication::translate ( "PrefsDlg", "&Size", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "PrefsDlg", "Background properties:", 0, QApplication::UnicodeUTF8 ) );

#ifndef QT_NO_TOOLTIP
	bgSelect->setToolTip ( QApplication::translate ( "PrefsDlg", "Report field background color", 0, QApplication::UnicodeUTF8 ) );
#endif // QT_NO_TOOLTIP

	bgSelect->setText ( QApplication::translate ( "PrefsDlg", "Type:", 0, QApplication::UnicodeUTF8 ) );
	colRadio->setText ( QApplication::translate ( "PrefsDlg", "&Color", 0, QApplication::UnicodeUTF8 ) );
	imgRadio->setText ( QApplication::translate ( "PrefsDlg", "&Image", 0, QApplication::UnicodeUTF8 ) );
	bgLabel->setText ( QApplication::translate ( "PrefsDlg", "&Color:", 0, QApplication::UnicodeUTF8 ) );
	backButton->setText ( QString() );
	tabWidget->setTabText ( tabWidget->indexOf ( intSE ), QApplication::translate ( "PrefsDlg", "Edit Style", 0, QApplication::UnicodeUTF8 ) );
	copyTool->setText ( QApplication::translate ( "PrefsDlg", "...", 0, QApplication::UnicodeUTF8 ) );
	pasteTool->setText ( QApplication::translate ( "PrefsDlg", "...", 0, QApplication::UnicodeUTF8 ) );
	cutTool->setText ( QApplication::translate ( "PrefsDlg", "...", 0, QApplication::UnicodeUTF8 ) );
	undoTool->setText ( QApplication::translate ( "PrefsDlg", "...", 0, QApplication::UnicodeUTF8 ) );
	redoTool->setText ( QApplication::translate ( "PrefsDlg", "...", 0, QApplication::UnicodeUTF8 ) );
	previewButton->setText ( QApplication::translate ( "PrefsDlg", "Preview", 0, QApplication::UnicodeUTF8 ) );
	testColor->setText ( QApplication::translate ( "PrefsDlg", "Get Color", 0, QApplication::UnicodeUTF8 ) );
	saveCSSButton->setText ( QApplication::translate ( "PrefsDlg", "Save", 0, QApplication::UnicodeUTF8 ) );
	tabWidget->setTabText ( tabWidget->indexOf ( extSE ), QApplication::translate ( "PrefsDlg", "Edit CSS", 0, QApplication::UnicodeUTF8 ) );
	label_2->setText ( QApplication::translate ( "PrefsDlg", "&Pdftk binary:", 0, QApplication::UnicodeUTF8 ) );
	pdftkTick->setText ( QApplication::translate ( "PrefsDlg", "...", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "PrefsDlg", "&Viewer (full path):", 0, QApplication::UnicodeUTF8 ) );
	viewerEdit->clear();
	viewerEdit->insertItems ( 0, QStringList()
	                          << QApplication::translate ( "PrefsDlg", "System", 0, QApplication::UnicodeUTF8 )
	                          << QApplication::translate ( "PrefsDlg", "Custom", 0, QApplication::UnicodeUTF8 )
	                        );
	searchViewer->setText ( QApplication::translate ( "PrefsDlg", "...", 0, QApplication::UnicodeUTF8 ) );
	searchTK->setText ( QApplication::translate ( "PrefsDlg", "...", 0, QApplication::UnicodeUTF8 ) );
	lfLabel->setText ( QApplication::translate ( "PrefsDlg", "&Look & Feel:", 0, QApplication::UnicodeUTF8 ) );
	StyleCombo->clear();
	StyleCombo->insertItems ( 0, QStringList()
	                          << QApplication::translate ( "PrefsDlg", "Cleanlooks", 0, QApplication::UnicodeUTF8 )
	                          << QApplication::translate ( "PrefsDlg", "Plastique", 0, QApplication::UnicodeUTF8 )
	                          << QApplication::translate ( "PrefsDlg", "Motif", 0, QApplication::UnicodeUTF8 )
	                        );
#if QT_VERSION >= 0x040500
	StyleCombo->insertItem ( 4, QApplication::translate ( "PrefsDlg", "GTK", 0, QApplication::UnicodeUTF8 ) );
#endif
	cssCheckBox->setText ( QApplication::translate ( "PrefsDlg", "External StyleSheet", 0, QApplication::UnicodeUTF8 ) );
	cssButton->setText ( QApplication::translate ( "PrefsDlg", "default.css", 0, QApplication::UnicodeUTF8 ) );
	langGroup->setTitle ( QApplication::translate ( "PrefsDlg", "Language:", 0, QApplication::UnicodeUTF8 ) );
	langCombo->clear();
//////////////////////////////////////////////////////////////////////////////////////////////////////
	orientLabel->setText ( QApplication::translate ( "PrefsDlg", "Page Orientation:", 0, QApplication::UnicodeUTF8 ) );
	orientCombo->clear();
	orientCombo->insertItems ( 0, QStringList()
	                           << QApplication::translate ( "PrefsDlg", "Portrait", 0, QApplication::UnicodeUTF8 )
	                           << QApplication::translate ( "PrefsDlg", "Landscape", 0, QApplication::UnicodeUTF8 )
	                         );
	resolLabel->setText ( QApplication::translate ( "PrefsDlg", "Resolution:", 0, QApplication::UnicodeUTF8 ) );
	colorMLabel->setText ( QApplication::translate ( "PrefsDlg", "Color Mode:", 0, QApplication::UnicodeUTF8 ) );
	colorMCombo->clear();
	colorMCombo->insertItems ( 0, QStringList()
	                           << QApplication::translate ( "PrefsDlg", "Color", 0, QApplication::UnicodeUTF8 )
	                           << QApplication::translate ( "PrefsDlg", "GrayScale", 0, QApplication::UnicodeUTF8 )
	                         );
	orderLabel->setText ( QApplication::translate ( "PrefsDlg", "Page Order:", 0, QApplication::UnicodeUTF8 ) );
	orderCombo->clear();
	orderCombo->insertItems ( 0, QStringList()
	                          << QApplication::translate ( "PrefsDlg", "Normal", 0, QApplication::UnicodeUTF8 )
	                          << QApplication::translate ( "PrefsDlg", "Reverse", 0, QApplication::UnicodeUTF8 )
	                        );
	tabWidget->setTabText ( tabWidget->indexOf ( printerSet ), QApplication::translate ( "PrefsDlg", "PDF Printer", 0, QApplication::UnicodeUTF8 ) );
//////////////////////////////////////////////////////

//////////////////////////////////////////////////////
	askdirBox->setText ( QApplication::translate ( "PrefsDlg", "Notify about active directory before script execution", 0, QApplication::UnicodeUTF8 ) );
	label_10->setText ( QApplication::translate ( "PrefsDlg", "Number of favorite scripts:", 0, QApplication::UnicodeUTF8 ) );
	favScriptBox->setTitle ( QApplication::translate ( "PrefsDlg", "Favorite scripts:", 0, QApplication::UnicodeUTF8 ) );
	tabWidget->setTabText ( tabWidget->indexOf ( scriptTab ), QApplication::translate ( "PrefsDlg", "Scripts", 0, QApplication::UnicodeUTF8 ) );
//////////////////////////////////////////////////////
	CAB->setText ( QApplication::translate ( "PrefsDlg", "&Cancel", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "PrefsDlg", "&OK", 0, QApplication::UnicodeUTF8 ) );
////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	imgCombo = new QComboBox ( layoutWidget2 );
	imgCombo->setObjectName ( QString::fromUtf8 ( "imgCombo" ) );
	imgCombo->hide();
	searchTK->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DirOpenIcon) ) );
	searchViewer->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DirOpenIcon) ) );
	copyTool->setIcon ( QIcon ( ":/copy" ) );
	copyTool->setToolTip ( tr ( "Copy" ) );
	cutTool->setIcon ( QIcon ( ":/cut" ) );
	cutTool->setToolTip ( tr ( "Cut" ) );
	pasteTool->setIcon ( QIcon ( ":/paste" ) );
	pasteTool->setToolTip ( tr ( "Paste" ) );
	undoTool->setIcon ( QIcon ( ":/undo" ) );
	undoTool->setToolTip ( tr ( "Undo" ) );
	redoTool->setIcon ( QIcon ( ":/redo" ) );
	redoTool->setToolTip ( tr ( "Redo" ) );
	copyTool->setEnabled ( false );
	cutTool->setEnabled ( false );
	if ( clipb->text() == "" ) pasteTool->setEnabled ( false );
	//connect ( viewerEdit, SIGNAL ( textChanged ( QString ) ), this, SLOT ( onViewerEdit ( QString ) ) );
	connect ( viewerEdit, SIGNAL ( activated ( int ) ), this, SLOT ( onViewerCombo ( int ) ) );
	connect ( pdftkEdit, SIGNAL ( textChanged ( QString ) ), this, SLOT ( onPdfTkEdit ( QString ) ) );
	connect ( searchTK, SIGNAL ( clicked() ), this, SLOT ( on_searchTK() ) );
	connect ( searchViewer, SIGNAL ( clicked() ), this, SLOT ( on_searchViewer() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( onOK() ) );
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( onCancel() ) );
	connect ( backButton, SIGNAL ( clicked() ), this, SLOT ( onBackC() ) );
	connect ( colorButton, SIGNAL ( clicked() ), this, SLOT ( onTextC() ) );
	connect ( addButton, SIGNAL ( clicked() ), this, SLOT ( onAdd() ) );
	connect ( remButton, SIGNAL ( clicked() ), this, SLOT ( onRemove() ) );
	connect ( saveButton, SIGNAL ( clicked() ), this, SLOT ( onSaveDB() ) );
	connect ( imgRadio, SIGNAL ( clicked ( bool ) ), this, SLOT ( onImgR ( bool ) ) );
	connect ( colRadio, SIGNAL ( clicked ( bool ) ), this, SLOT ( onColR ( bool ) ) );
	connect ( cssCheckBox, SIGNAL ( clicked ( bool ) ), this, SLOT ( onCssCheck ( bool ) ) );
	connect ( cssButton, SIGNAL ( clicked () ), this, SLOT ( onCssButton() ) );
	connect ( saveCSSButton, SIGNAL ( clicked () ), this, SLOT ( onSaveCss() ) );
	connect ( previewButton, SIGNAL ( clicked () ), this, SLOT ( onPreview() ) );
	connect ( testColor, SIGNAL ( clicked () ), this, SLOT ( onGetColor() ) );
	connect ( cssEdit, SIGNAL ( copyAvailable ( bool ) ), this, SLOT ( onCopyAvailable ( bool ) ) );
	connect ( cssEdit, SIGNAL ( undoAvailable ( bool ) ), this, SLOT ( onUndoAvailable ( bool ) ) );
	connect ( cssEdit, SIGNAL ( redoAvailable ( bool ) ), this, SLOT ( onRedoAvailable ( bool ) ) );
	connect ( cssEdit, SIGNAL ( textChanged() ), this, SLOT ( onCssChange() ) );
	connect ( clipb, SIGNAL ( dataChanged() ), this, SLOT ( onPasteAvailable() ) );
	connect ( copyTool, SIGNAL ( clicked () ), cssEdit, SLOT ( copy() ) );
	connect ( pasteTool, SIGNAL ( clicked () ), cssEdit, SLOT ( paste() ) );
	connect ( undoTool, SIGNAL ( clicked () ), cssEdit, SLOT ( undo() ) );
	connect ( redoTool, SIGNAL ( clicked () ), cssEdit, SLOT ( redo() ) );
	connect ( cutTool, SIGNAL ( clicked () ), cssEdit, SLOT ( cut() ) );
	connect ( favSpin, SIGNAL ( valueChanged ( int ) ), this, SLOT ( onFavScriptNum ( int ) ) );
	OKB->setDefault ( true );
	cssChanged = false;
	cssEdit->setStyleSheet ( "QTextEdit{background: white; color: black;}" );
	colorEdit->setInputMask ( "\\#HHHHHH" );colorEdit->setText ( "#ffffff" );
	backEdit->setInputMask ( "\\#HHHHHH" );backEdit->setText ( "#000000" );
	backButton->setIcon ( QIcon ( ":/color" ) );
	colorButton->setIcon ( QIcon ( ":/color" ) );
	colRadio->setChecked ( true );
	index = new int[6];
	fontSpin->setRange ( 1, 72 );
	tabWidget->setTabToolTip ( 0, tr ( "Edit:\n-Report field preferences\n-Dialog backgrounds" ) );
	tabWidget->setTabToolTip ( 1, tr ( "Edit selected css file" ) );
	readSettings();
	connect ( imgCombo, SIGNAL ( activated ( QString ) ), this, SLOT ( onImgC ( QString ) ) );
	connect ( langCombo, SIGNAL ( activated ( int ) ), this, SLOT ( onLangCombo ( int ) ) );
/////////////////////////////
}
void PrefsDlg::onLangCombo ( int i )
{
	if ( i == 2 )
	{
		locFile = QFileDialog::getOpenFileName ( this , "Translation File", QDir().homePath(), "*.qm" );
		if ( !locFile.isEmpty() )
		{
			langCombo->setToolTip ( locFile );
		}
	}
	else	langCombo->setToolTip ( "" );
}
void PrefsDlg::onCssChange()
{
	tabWidget->setTabText ( tabWidget->indexOf ( extSE ), QApplication::translate ( "PrefsDlg", "*Edit CSS", 0, QApplication::UnicodeUTF8 ) );
	cssChanged = true;
}
void PrefsDlg::onCopyAvailable ( bool yes )
{
	if ( yes )
	{
		copyTool->setEnabled ( true );
		cutTool->setEnabled ( true );
	}
	else
	{
		copyTool->setEnabled ( false );
		cutTool->setEnabled ( false );
	}
}
void PrefsDlg::onPasteAvailable()
{
	if ( clipb->text() == "" ) pasteTool->setEnabled ( false );
	else pasteTool->setEnabled ( true );
}
void PrefsDlg::onUndoAvailable ( bool yes )
{
	if ( yes ) undoTool->setEnabled ( true );
	else undoTool->setEnabled ( false );
}
void PrefsDlg::onRedoAvailable ( bool yes )
{
	if ( yes ) redoTool->setEnabled ( true );
	else redoTool->setEnabled ( false );
}
void PrefsDlg::onGetColor()
{
	cssEdit->copy();
	QColor temp = QColorDialog::getColor ( QColor ( clipb->text() ), this );
	if ( temp.isValid() )
	{
		cssEdit->insertPlainText ( temp.name() );
	}
}
void PrefsDlg::onPreview()
{
	Preview *pre = new Preview ( this, Qt::Dialog, cssEdit->toPlainText() );
	pre->exec();
}
void PrefsDlg::onImgC ( QString text )
{
	if ( text == "Custom" )
	{
		backListText.clear();
		for ( int i=0;i<backList->count();i++ ) {backListText<<backList->item ( i )->text();}
		BackSel *s = new BackSel ( this, Qt::Popup, &backListText, index );
		if ( s->exec() == 1 )
		{
			index[0] = backListText[0].toInt();
			index[1] = backListText[1].toInt();
			index[2] = backListText[2].toInt();
			index[3] = backListText[3].toInt();
			index[4] = backListText[4].toInt();
			index[5] = -1;
		}
	}
	else{for ( int i=0;i<5;i++ ) {index[i] = -1;} index[5] = imgCombo->currentIndex();}
}
void PrefsDlg::onImgR ( bool check )
{
	if ( check )
	{
		horizontalLayout_3->removeWidget ( backEdit );
		backEdit->hide();
		horizontalLayout_3->removeWidget ( backButton );
		backButton->hide();
		horizontalLayout_3->addWidget ( imgCombo );
		imgCombo->show();
		bgLabel->setBuddy ( imgCombo );
		bgLabel->setText ( tr ( "&Image:" ) );
	}
}
void PrefsDlg::onColR ( bool check )
{
	if ( check )
	{
		horizontalLayout_3->removeWidget ( imgCombo );
		imgCombo->hide();
		horizontalLayout_3->addWidget ( backEdit );
		backEdit->show();
		horizontalLayout_3->addWidget ( backButton );
		backButton->show();
		bgLabel->setBuddy ( backEdit );
		bgLabel->setText ( tr ( "&Color:" ) );
	}
}

void PrefsDlg::onFavScriptNum ( int num )
{
	qDebug() <<"favNum "<<num;
	favNum = num;
	if ( num > 0 ) favScriptBox->setEnabled ( true );
	for ( int i=0;i<5;i++ )
	{
		if ( i >= favNum )
		{
			favLabels[i]->setVisible ( false );
			favCombos[i]->setVisible ( false );
		}
		else
		{
			favLabels[i]->setVisible ( true );
			favCombos[i]->setVisible ( true );
		}
	}
}
void PrefsDlg::onCssCheck ( bool check )
{
	if ( check )
	{
		if ( cssFile == "" )
		{
			//QMessageBox::warning ( this, "", tr ( "You have not specified any css file!" ) );
			onCssButton();
			//cssCheckBox->setChecked ( false );
		}
		else
		{
			QFile *tfile = new QFile ( cssFile );
			if ( tfile->exists() )
			{
				if ( !tfile->open ( QFile::ReadOnly | QFile::Text ) )
				{
					QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot open css file" ) );
				}
				else
				{
					QTextStream in ( tfile );
					cssEdit->setText ( in.readAll() );
					cssChanged = false;
					tabWidget->setTabText ( tabWidget->indexOf ( extSE ), QApplication::translate ( "PrefsDlg", "Edit CSS", 0, QApplication::UnicodeUTF8 ) );
					intSE->setEnabled ( false );
					extSE->setEnabled ( true );
					tabWidget->setCurrentIndex ( 1 );
					tfile->close();
				}
			}
			else{QMessageBox::warning ( this, "", tr ( "Css file does not exist!\nPlease specify a valid css file!" ) );cssCheckBox->setChecked ( false );}
		}
	}
	else{extSE->setEnabled ( false );intSE->setEnabled ( true );tabWidget->setCurrentIndex ( 0 );cssCheckBox->setChecked ( false );}
}
void PrefsDlg::onSaveCss()
{
	QFile *tfile = new QFile ( cssFile );
	if ( !tfile->open ( QFile::WriteOnly | QFile::Text ) )
	{
		QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot save css file" ) );
	}
	else
	{
		QTextStream out ( tfile );
		out<<cssEdit->toPlainText();
		cssChanged = false;
		tabWidget->setTabText ( tabWidget->indexOf ( extSE ), QApplication::translate ( "PrefsDlg", "Edit CSS", 0, QApplication::UnicodeUTF8 ) );
		tfile->close();
	}
}
void PrefsDlg::onCssButton()
{
	if ( !cssFile.isEmpty() && cssChanged )
	{
		if ( QMessageBox::question ( this, tr ( "Save?" ), tr ( "Save changes to css file?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) {onSaveCss();}
	}
	QString file = QFileDialog::getOpenFileName ( this, tr ( "Select css file:" ), QDir().homePath() +"/.suslictk", tr ( "StyleSheet (*.css  *.qss)" ) );
	if ( !file.isEmpty() ) {cssFile = file;cssButton->setText ( file.split ( "/", QString::SkipEmptyParts ).last() );if ( cssCheckBox->isChecked() ) onCssCheck ( true );}
	else{if ( cssFile.isEmpty() ) onCssCheck ( false );}
}
void PrefsDlg::onAdd()
{
	QStringList files = QFileDialog::getOpenFileNames ( this, tr ( "Select image(s)" ), QDir().homePath(), tr ( "Images (*.png *.svg)" ) );
	if ( !files.isEmpty() ) {backList->addItems ( files );}
}
void PrefsDlg::onRemove()
{
	qDebug() <<"backList->count() = "<<backList->count() <<" - not removed";
	if ( backList->currentRow() >=0 ) backList->takeItem ( backList->currentRow() );
	qDebug() <<"backList->count() = "<<backList->count() <<" - removed";
}
void PrefsDlg::onBackC()
{
	QColor temp = QColorDialog::getColor ( QColor ( backEdit->text() ), this );
	if ( temp.isValid() ) {backEdit->setText ( "#"+temp.name() );}
}
void PrefsDlg::onTextC()
{
	QColor temp = QColorDialog::getColor ( QColor ( colorEdit->text() ), this );
	if ( temp.isValid() ) {colorEdit->setText ( "#"+temp.name() );}
}
void PrefsDlg::on_searchTK()
{
	QString tkBin = QFileDialog::getOpenFileName ( this, tr ( "PdfTk binary" ), "/usr/bin", "pdftk" );
	pdftkEdit->setText ( tkBin );
	onPdfTkEdit ( tkBin );
}
void PrefsDlg::on_searchViewer()
{
	vBin = QFileDialog::getOpenFileName ( this, tr ( "Viewer binary" ), "/usr/bin");
	if ( QFileInfo ( vBin ).isExecutable() && !QFileInfo ( vBin ).isDir() )
	{
		viewerEdit->setToolTip(vBin);
	}
	else
	{
		vBin = "@native";
		viewerEdit->setCurrentIndex(0);
	}
}
void PrefsDlg::onPdfTkEdit ( QString str )
{
	if ( QFileInfo ( str ).isExecutable() && !QFileInfo ( str ).isDir() && str != qApp->applicationFilePath() && str != QFileInfo(qApp->applicationFilePath()).fileName())
	{
		pdftkTick->setPixmap ( QPixmap ( ":/oktick" ) );
		tkok = true;
	}
	else
	{
		pdftkTick->setPixmap ( QPixmap ( ":/notick" ) );
		tkok = false;
	}
}
void PrefsDlg::onViewerCombo( int i)
{
	if(i==0) vBin="@native";
	else
	{
		on_searchViewer();
	}
}
void PrefsDlg::onOK()
{
	if ( tkok )
	{
		if ( !rcfile->open ( QFile::WriteOnly | QFile::Text ) )
		{
			QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),
			                       tr ( "Cannot write file %1:\n%2." )
			                       .arg ( rcfile->fileName() )
			                       .arg ( rcfile->errorString() ) );
			if ( cssChanged ) {if ( QMessageBox::question ( this, tr ( "Save?" ), tr ( "Save changes to css file?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) onSaveCss();}
			reject();
		}

		QTextStream out ( rcfile );
		QApplication::setOverrideCursor ( Qt::WaitCursor );
		out << "[version]\n"+vers+"\n[pdftkbinary]\n"+pdftkEdit->text() +"\n[viewer]\n"+vBin+"\n[lookandfeel]\n"+StyleCombo->itemText ( StyleCombo->currentIndex() ) +"\n[background_main]\n"+backEdit->text() +"\n[printer]\n"+tr ( "%1" ).arg ( orientCombo->currentIndex() ) +";"+tr ( "%1" ).arg ( resolSpin->value() ) +";"+tr ( "%1" ).arg ( colorMCombo->currentIndex() ) +";"+tr ( "%1" ).arg ( orderCombo->currentIndex() ) +"\n[textcolor_main]\n"+colorEdit->text() +"\n[font-size]\n"+tr ( "%1" ).arg ( fontSpin->value() ) +"\n[font-family]\n"+fontCombo->currentText();
		QFile *imgfile = new QFile ( QDir().homePath() +"/.suslictk/bgimg.rc" );
		if ( backList->count() > 0 )
		{
			if ( index[0]>=0 && index[0]<backList->count() ) {out<<"\n[background-cat]\n"<<index[0];}
			if ( index[1]>=0 && index[1]<backList->count() ) {out<<"\n[background-bur]\n"<<index[1];}
			if ( index[2]>=0 && index[2]<backList->count() ) {out<<"\n[background-att]\n"<<index[2];}
			if ( index[3]>=0 && index[3]<backList->count() ) {out<<"\n[background-encr]\n"<<index[3];}
			if ( index[4]>=0 && index[4]<backList->count() ) {out<<"\n[background-report]\n"<<index[4];}
			if ( index[5]>=0 && index[5]<backList->count() ) {out<<"\n[background-common]\n"+tr ( "%1" ).arg ( imgCombo->currentIndex() );}
			if ( !imgfile->open ( QFile::WriteOnly | QFile::Text ) )
			{
				QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot write to file %1:\n%2." ).arg ( imgfile->fileName() ).arg ( imgfile->errorString() ) );
			}
			QTextStream imgout ( imgfile );bgPath.clear();
			for ( int i=0;i<backList->count();i++ )
				{imgout << backList->item ( i )->text() <<"\n";}
			imgfile->close();

		}
		else
		{
			if ( !imgfile->remove() ) {qDebug() <<"failed to remove bgimg.rc\nAlready removed?";}
			else{qDebug() <<"bgimg.rc removed!";}
		}
		if ( cssCheckBox->isChecked() )
		{
			out<<"\n[ext-css]\n"+cssFile;
		}

		out<<"\n[fav-scripts]\n";
		for ( int i=0;i<favNum;i++ )
		{
			out<<favCombos[i]->currentText();
			if ( i != favNum-1 ) out<<";";
		}

		if ( cssChanged )
		{
			if ( QMessageBox::question ( this, tr ( "Save?" ), tr ( "Save changes to css file?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) {onSaveCss();}
		}
		rcfile->close();
		QSettings set;
		set.setValue ( "AskChDir", askdirBox->isChecked() );
		QString lang = set.value ( "Language", QString ( "en" ) ).toString();
		switch ( langCombo->currentIndex() )
		{
			case 0:
				if ( lang != "en" )
				{
					set.setValue ( "Language", "en" );
					QMessageBox::warning ( this,tr ( "Attention" ), tr ( "You have to restart the application to change the language" ) );
				}
				break;
			case 1:
				if ( lang != "loc" )
				{
					set.setValue ( "Language", "loc" );
					QMessageBox::warning ( this,tr ( "Attention" ), tr ( "You have to restart the application to change the language" ) );
				}
				break;
			case 2:
				set.setValue ( "Language", "custom" );
				set.setValue ( "LanguageFile", locFile );
				QMessageBox::warning ( this,tr ( "Attention" ), tr ( "You have to restart the application to change the language" ) );
				break;
			default: /*should never happen*/ break;
		}
		set.setValue ( "FavScriptNum", favNum );

		QApplication::restoreOverrideCursor();
		accept();
	}
	else
	{
		QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Incorrect pdftk binary path. No conf. file will be created!" ) );
		if ( cssChanged ) {if ( QMessageBox::question ( this, tr ( "Save?" ), tr ( "Save changes to css file?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) onSaveCss();}
		reject();
	}
}
void PrefsDlg::onCancel()
{
	if ( cssChanged )
	{
		if ( QMessageBox::question ( this, tr ( "Save?" ), tr ( "Save changes to css file?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) {onSaveCss();}
	}
	reject();
}
void PrefsDlg::closeEvent ( QCloseEvent *event )
{
	if ( cssChanged )
	{
		if ( QMessageBox::question ( this, tr ( "Save?" ), tr ( "Save changes to css file?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes ) {onSaveCss();}
	}
	event->accept();
}
void PrefsDlg::onSaveDB()
{
	QApplication::setOverrideCursor ( Qt::WaitCursor );
	QDir *homePDF = new QDir ( QDir().homePath() + "/.suslictk" );
	if ( !homePDF->exists() )
	{
		if ( !homePDF->mkdir ( homePDF->absolutePath() ) )
			{QMessageBox::critical ( this, tr ( "ERROR" ), tr ( "Something wrong!\nCannot create directory\nCheck rights\nWill now exit" ) );reject();}
	}
	QFile *imgfile = new QFile ( homePDF->absolutePath() +"/bgimg.rc" );
	if ( backList->count() > 0 )
	{
		if ( !imgfile->open ( QFile::WriteOnly | QFile::Text ) )
		{
			QMessageBox::warning ( this, tr ( "PdfTk-QGUI" ),tr ( "Cannot write to file %1:\n%2." ).arg ( homePDF->absolutePath() +"/bgimg.rc" ).arg ( imgfile->errorString() ) );
		}
		QTextStream imgout ( imgfile );bgPath.clear();
		for ( int i=0;i<backList->count();i++ )
			{QString s =backList->item ( i )->text();bgPath<<s.split ( "/", QString::SkipEmptyParts ).last();imgout << s <<"\n";}
		imgfile->close();
		bgPath<<"Custom";
	}
	else
	{
		if ( !imgfile->remove() ) {qDebug() <<"failed to remove bgimg.rc\nAlready removed?";}
		else{qDebug() <<"bgimg.rc removed!";}
		bgPath.clear();
	}
	QApplication::restoreOverrideCursor();
	imgCombo->clear();
	if ( ImportTheme ( QDir().homePath() +"/.suslictk/bgimg.rc", &bgPath ) )
	{
		for ( int i=0;i<bgPath.count(); i++ )
			{bgPath[i] = bgPath[i].split ( "/", QString::SkipEmptyParts ).last();}

		bgPath<<"Custom";
		imgCombo->insertItems ( 0, bgPath );
		if ( index[5]>=0 && index[5] < imgCombo->count()-1 ) {imgCombo->setCurrentIndex ( index[5] );}
		if ( index[0]>=0 || index[1]>=0 || index[2]>=0 || index[3]>=0 || index[4]>=0 ) {imgCombo->setCurrentIndex ( imgCombo->count()-1 );}
	}
}
PrefsDlg::~PrefsDlg()
{
	destroy();
}
