/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Rebuild.h"

Rebuild::Rebuild ( QWidget *parent, Qt::WindowFlags f, QString ifile, QString pdftkBin, QString viewerBin, QString bg1, QString ldir )
{
	bg = bg1;
	ladir = ldir;
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	pdftk = pdftkBin;
	if ( !viewerBin.isEmpty() ) {viewer = viewerBin;}
	this->setObjectName ( QString::fromUtf8 ( "Rebuild" ) );
	resize ( 420, 430 );
	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	//groupBox->setGeometry ( QRect ( 10, 300, 381, 61 ) );
	//widget = new QWidget ( groupBox );
	//widget->setObjectName ( QString::fromUtf8 ( "widget" ) );
	//widget->setGeometry ( QRect ( 20, 20, 341, 27 ) );
	horizontalLayout_4 = new QHBoxLayout ( groupBox );
	horizontalLayout_4->setObjectName ( QString::fromUtf8 ( "horizontalLayout_4" ) );
	//horizontalLayout_4->setContentsMargins ( 0, 0, 0, 0 );
	createRadio = new QRadioButton ( groupBox );
	createRadio->setObjectName ( QString::fromUtf8 ( "createRadio" ) );

	horizontalLayout_4->addWidget ( createRadio );

	overRadio = new QRadioButton ( groupBox );
	overRadio->setObjectName ( QString::fromUtf8 ( "overRadio" ) );

	horizontalLayout_4->addWidget ( overRadio );

	layoutWidget = new QWidget ( this );
	layoutWidget->setObjectName ( QString::fromUtf8 ( "layoutWidget" ) );
	horizontalLayout_5 = new QHBoxLayout ( layoutWidget );
	horizontalLayout_5->setObjectName ( QString::fromUtf8 ( "horizontalLayout_5" ) );
	//horizontalLayout_4->setContentsMargins ( 0, 0, 0, 0 );
	PageList = new QListWidget ( layoutWidget );
	PageList->setObjectName ( QString::fromUtf8 ( "PageList" ) );
	//PageList->setGeometry ( QRect ( 10, 50, 261, 241 ) );
	horizontalLayout_5->addWidget ( PageList );

	groupBox_2 = new QGroupBox ( this );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	//groupBox_2->setGeometry ( QRect ( 280, 50, 111, 241 ) );
	//widget1 = new QWidget ( groupBox_2 );
	//widget1->setObjectName ( QString::fromUtf8 ( "widget1" ) );
	//widget1->setGeometry ( QRect ( 10, 20, 89, 211 ) );
	verticalLayout = new QVBoxLayout ( groupBox_2 );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	//verticalLayout->setContentsMargins ( 0, 0, 0, 0 );
	addButton = new QPushButton ( groupBox_2 );
	addButton->setObjectName ( QString::fromUtf8 ( "addButton" ) );

	addMenu = new QMenu ( tr ( "&Add" ), this );
	rangeAdd = new QAction ( tr ( "Add range" ), this );
	rangeAdd->setObjectName ( QString::fromUtf8 ( "rangeAdd" ) );
	pagesAdd = new QAction ( tr ( "Add pages" ), this );
	pagesAdd->setObjectName ( QString::fromUtf8 ( "pagesAdd" ) );
	addMenu->addAction ( rangeAdd );
	addMenu->addAction ( pagesAdd );
	addButton->setMenu ( addMenu );

	verticalLayout->addWidget ( addButton );

	editButton = new QPushButton ( groupBox_2 );
	editButton->setObjectName ( QString::fromUtf8 ( "editButton" ) );

	verticalLayout->addWidget ( editButton );

	remButton = new QPushButton ( groupBox_2 );
	remButton->setObjectName ( QString::fromUtf8 ( "remButton" ) );

	verticalLayout->addWidget ( remButton );

	upButton = new QPushButton ( groupBox_2 );
	upButton->setObjectName ( QString::fromUtf8 ( "upButton" ) );

	verticalLayout->addWidget ( upButton );

	downButton = new QPushButton ( groupBox_2 );
	downButton->setObjectName ( QString::fromUtf8 ( "downButton" ) );

	verticalLayout->addWidget ( downButton );

	horizontalLayout_5->addWidget ( groupBox_2 );

	widget2 = new QWidget ( this );
	widget2->setObjectName ( QString::fromUtf8 ( "widget2" ) );
	//widget2->setGeometry ( QRect ( 10, 380, 381, 33 ) );
	horizontalLayout_2 = new QHBoxLayout ( widget2 );
	horizontalLayout_2->setObjectName ( QString::fromUtf8 ( "horizontalLayout_2" ) );
	//horizontalLayout_2->setContentsMargins ( 0, 0, 0, 0 );
	closeCheck = new QCheckBox ( widget2 );
	closeCheck->setObjectName ( QString::fromUtf8 ( "closeCheck" ) );

	horizontalLayout_2->addWidget ( closeCheck );

	horizontalLayout = new QHBoxLayout();
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	CAB = new QPushButton ( widget2 );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout->addWidget ( CAB );

	OKB = new QPushButton ( widget2 );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout->addWidget ( OKB );


	horizontalLayout_2->addLayout ( horizontalLayout );

	widget3 = new QWidget ( this );
	widget3->setObjectName ( QString::fromUtf8 ( "widget3" ) );
	widget3->setGeometry ( QRect ( 10, 10, 381, 31 ) );
	horizontalLayout_3 = new QHBoxLayout ( widget3 );
	horizontalLayout_3->setObjectName ( QString::fromUtf8 ( "horizontalLayout_3" ) );
	horizontalLayout_3->setContentsMargins ( 0, 0, 0, 0 );
	label = new QLabel ( widget3 );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	horizontalLayout_3->addWidget ( label );

	ifileEdit = new QLineEdit ( widget3 );
	ifileEdit->setObjectName ( QString::fromUtf8 ( "ifileEdit" ) );

	horizontalLayout_3->addWidget ( ifileEdit );

	chooseButton = new QToolButton ( widget3 );
	chooseButton->setObjectName ( QString::fromUtf8 ( "chooseButton" ) );
	chooseButton->setToolTip ( tr ( "Select document to be rebuilt" ) );

	horizontalLayout_3->addWidget ( chooseButton );

	previewButton = new QToolButton ( widget3 );
	previewButton->setObjectName ( QString::fromUtf8 ( "previewButton" ) );
	previewButton->setToolTip ( tr ( "View selected document" ) );

	horizontalLayout_3->addWidget ( previewButton );

	verticalLayout_2 = new QVBoxLayout ( this );
	verticalLayout_2->setObjectName ( QString::fromUtf8 ( "verticalLayout_2" ) );

	verticalLayout_2->addWidget ( widget3 );
	verticalLayout_2->addWidget ( layoutWidget );
	verticalLayout_2->addWidget ( groupBox );
	verticalLayout_2->addWidget ( widget2 );

	retranslateUi();
	label->setBuddy ( ifileEdit );
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( chooseButton, SIGNAL ( clicked() ), this, SLOT ( onChoose() ) );
	QMetaObject::connectSlotsByName ( this );
//////////////////////////
	if ( !bg.isEmpty() ) {qDebug() <<"REBUILD: background!";setStyleSheet ( tr ( "QDialog{background: url(%1);}" ).arg ( bg ) );}
	createRadio->setChecked ( true );
	OKB->setEnabled ( false );
	groupBox->setEnabled ( false );
	groupBox_2->setEnabled ( false );
	ifileEdit->setReadOnly ( true );
	closeCheck->setChecked ( true );
	previewButton->setEnabled ( false );
//////////////////////////
	if(!ifile.isEmpty())	onChoose(ifile);
}
void Rebuild::retranslateUi()
{
	setWindowTitle ( QApplication::translate ( "Rebuild", "Rebuild", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "Rebuild", "Output file:", 0, QApplication::UnicodeUTF8 ) );
	createRadio->setText ( QApplication::translate ( "Rebuild", "Create &new", 0, QApplication::UnicodeUTF8 ) );
	overRadio->setText ( QApplication::translate ( "Rebuild", "&Overwrite existing", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setTitle ( QApplication::translate ( "Rebuild", "Page range:", 0, QApplication::UnicodeUTF8 ) );
	addButton->setText ( QApplication::translate ( "Rebuild", "&Add", 0, QApplication::UnicodeUTF8 ) );
	editButton->setText ( QApplication::translate ( "Rebuild", "&Edit", 0, QApplication::UnicodeUTF8 ) );
	remButton->setText ( QApplication::translate ( "Rebuild", "Remove", 0, QApplication::UnicodeUTF8 ) );
	upButton->setText ( QApplication::translate ( "Rebuild", "Move &Up", 0, QApplication::UnicodeUTF8 ) );
	downButton->setText ( QApplication::translate ( "Rebuild", "Move &Down", 0, QApplication::UnicodeUTF8 ) );
	closeCheck->setText ( QApplication::translate ( "Rebuild", "&Close after operation", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "Rebuild", "&Close", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "Rebuild", "&OK", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "Rebuild", "&PDF file:", 0, QApplication::UnicodeUTF8 ) );
	chooseButton->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DirOpenIcon) ) );
	previewButton->setIcon ( QIcon ( ":/pdf" ) );
}
void Rebuild::keyPressEvent ( QKeyEvent *e )
{
	if ( e->key() == Qt::Key_R ) on_rangeAdd_triggered();
	if ( e->key() == Qt::Key_P ) on_pagesAdd_triggered();
	if ( e->key() == Qt::Key_D ) on_downButton_clicked();
	if ( e->key() == Qt::Key_U ) on_upButton_clicked();
	if ( e->key() == Qt::Key_E ) on_editButton_clicked();
	if ( e->key() == Qt::Key_C ) onChoose();
	if ( e->key() == Qt::Key_O ) on_OKB_clicked();
}
void Rebuild::on_rangeAdd_triggered()
{
	Page *p = new Page ( this, Qt::Popup, pageNum, bg );
	if ( p->exec() == 1 )
	{
		if ( p->pageF == p->pageT )
		{
			PageList->addItem ( tr ( "%1%2" ).arg ( p->pageF ).arg ( p->rotation ) );
		}
		else
		{
			if ( p->odd && p->even )
				{PageList->addItem ( tr ( "%1-%2%3" ).arg ( p->pageF ).arg ( p->pageT ).arg ( p->rotation ) );}
			if ( !p->odd && !p->even )
				{PageList->addItem ( tr ( "%1-%2%3" ).arg ( p->pageF ).arg ( p->pageT ).arg ( p->rotation ) );}
			if ( !p->odd && p->even )
				{PageList->addItem ( tr ( "%1-%2even%3" ).arg ( p->pageF ).arg ( p->pageT ).arg ( p->rotation ) );}
			if ( p->odd && !p->even )
				{PageList->addItem ( tr ( "%1-%2odd%3" ).arg ( p->pageF ).arg ( p->pageT ).arg ( p->rotation ) );}
		}
	}
}
void Rebuild::on_pagesAdd_triggered()
{
	QString pagess = QInputDialog::getText ( this, tr ( "Add pages" ), tr ( "Pages (space separated):" ) );
	if ( pagess.isEmpty() ) return;
	bool ok;
	QString rot = QInputDialog::getItem ( this,  tr ( "Add pages" ), tr ( "Rotation" ), QStringList()
	                                      << QApplication::translate ( "Cat", "None", 0, QApplication::UnicodeUTF8 )
	                                      << QApplication::translate ( "Cat", "North", 0, QApplication::UnicodeUTF8 )
	                                      << QApplication::translate ( "Cat", "East", 0, QApplication::UnicodeUTF8 )
	                                      << QApplication::translate ( "Cat", "South", 0, QApplication::UnicodeUTF8 )
	                                      << QApplication::translate ( "Cat", "West", 0, QApplication::UnicodeUTF8 )
	                                      << QApplication::translate ( "Cat", "Rotate +90", 0, QApplication::UnicodeUTF8 )
	                                      << QApplication::translate ( "Cat", "Rotate -90", 0, QApplication::UnicodeUTF8 )
	                                      << QApplication::translate ( "Cat", "Rotate 180", 0, QApplication::UnicodeUTF8 ), 0, false, &ok );
	qDebug() <<rot;
	if ( !ok ) return;
	rot = rot.replace ( QApplication::translate ( "Cat", "None", 0, QApplication::UnicodeUTF8 ), "" ).replace ( QApplication::translate ( "Cat", "North", 0, QApplication::UnicodeUTF8 ), "N" ).replace ( QApplication::translate ( "Cat", "East", 0, QApplication::UnicodeUTF8 ), "E" ).replace ( QApplication::translate ( "Cat", "South", 0, QApplication::UnicodeUTF8 ), "S" ).replace ( QApplication::translate ( "Cat", "West", 0, QApplication::UnicodeUTF8 ), "W" ).replace ( QApplication::translate ( "Cat", "Rotate +90", 0, QApplication::UnicodeUTF8 ), "R" ).replace ( QApplication::translate ( "Cat", "Rotate -90", 0, QApplication::UnicodeUTF8 ), "L" ).replace ( QApplication::translate ( "Cat", "Rotate 180", 0, QApplication::UnicodeUTF8 ), "D" );
	qDebug() <<rot;
	QStringList pageL= pagess.split ( " ", QString::SkipEmptyParts );
	for ( int i=0;i<pageL.count();i++ )
	{
		int tm = pageL[i].toInt();
		if ( tm > 0 && tm <=pageNum )
		{
			PageList->addItem ( tr ( "%1%2" ).arg ( tm ).arg ( rot ) );
		}
	}
}
void Rebuild::on_downButton_clicked()
{
	int NUMB = PageList->currentRow();
	//qDebug()<<"NUMB = "<<NUMB;
	if ( NUMB>=0 && NUMB< ( PageList->count()-1 ) )
	{
		QListWidgetItem ITEM = * ( PageList->item ( NUMB ) );
		* ( PageList->item ( NUMB ) ) = * ( PageList->item ( NUMB+1 ) );
		* ( PageList->item ( NUMB+1 ) ) = ITEM;
		PageList->setCurrentRow ( NUMB+1 );
	}
}
void Rebuild::on_editButton_clicked()
{
	int NUMB = PageList->currentRow();
	//qDebug()<<"NUMB = "<<NUMB;
	if ( NUMB>=0 )
	{
		QStringList tC = PageList->item ( NUMB )->text().split ( "-" );
		int _from, _to;
		if ( tC.count() < 2 ) {_from = _to = 1;}
		else
		{
			_from = tC[0].toInt();
			if ( tC[1].contains ( QRegExp ( "\\D$" ) ) )
			{
				tC[1].chop ( 1 );
				_to = tC[1].toInt();
				if ( _to == 0 )
				{
					if ( tC[1].contains ( "eve" ) ) {_to = tC[1].split ( "eve" ).first().toInt();}
					if ( tC[1].contains ( "od" ) ) {_to = tC[1].split ( "od" ).first().toInt();}
				}
			}
			else{_to = tC[1].toInt();}
		}
		Page *p = new Page ( this, Qt::Popup, pageNum, bg, _from, _to );
		if ( p->exec() == 1 )
		{
			delete PageList->takeItem ( NUMB );
			if ( p->pageF == p->pageT )
			{
				PageList->insertItem ( NUMB, tr ( "%1%2" ).arg ( p->pageF ).arg ( p->rotation ) );
			}
			else
			{
				if ( p->odd && p->even )
					{PageList->insertItem ( NUMB, tr ( "%1-%2%3" ).arg ( p->pageF ).arg ( p->pageT ).arg ( p->rotation ) );}
				if ( !p->odd && !p->even )
					{PageList->insertItem ( NUMB, tr ( "%1-%2%3" ).arg ( p->pageF ).arg ( p->pageT ).arg ( p->rotation ) );}
				if ( !p->odd && p->even )
					{PageList->insertItem ( NUMB, tr ( "%1-%2even%3" ).arg ( p->pageF ).arg ( p->pageT ).arg ( p->rotation ) );}
				if ( p->odd && !p->even )
					{PageList->insertItem ( NUMB, tr ( "%1-%2odd%3" ).arg ( p->pageF ).arg ( p->pageT ).arg ( p->rotation ) );}
			}
		}
	}
}
void Rebuild::on_remButton_clicked()
{
	int NUMB = PageList->currentRow();
	//qDebug()<<"NUMB = "<<NUMB;
	if ( NUMB>=0 )
	{
		delete PageList->takeItem ( NUMB );
	}
}
void Rebuild::on_upButton_clicked()
{
	int NUMB = PageList->currentRow();
	//qDebug()<<"NUMB = "<<NUMB;
	if ( NUMB>0 )
	{
		QListWidgetItem ITEM = * ( PageList->item ( NUMB ) );
		* ( PageList->item ( NUMB ) ) = * ( PageList->item ( NUMB-1 ) );
		* ( PageList->item ( NUMB-1 ) ) = ITEM;
		PageList->setCurrentRow ( NUMB-1 );
	}
}
void Rebuild::onChoose(QString ifile)
{
	QString file;
	if(ifile.isEmpty()) file = QFileDialog::getOpenFileName ( this, tr ( "Select PDF to rebuild:" ), ladir, tr ( "PDF documents (*.pdf)" ) );
	else file = ifile;
	if ( !file.isEmpty() )
	{
		ladir = QFileInfo ( file ).absolutePath();
		IFILE = file;ifileEdit->setText ( QFileInfo ( IFILE ).fileName() );
		PageList->clear();
		if ( addFile() )
		{
			OKB->setEnabled ( true );
			groupBox->setEnabled ( true );
			groupBox_2->setEnabled ( true );
			ifileEdit->setText ( tr ( "%1 : %2 pages" ).arg ( QFileInfo ( IFILE ).fileName() ).arg ( pageNum ) );
		}
		else
		{
			OKB->setEnabled ( false );
			groupBox->setEnabled ( false );
			groupBox_2->setEnabled ( false );
		}
		QApplication::restoreOverrideCursor();
	}
	if ( !IFILE.isEmpty() && !viewer.isEmpty() ) previewButton->setEnabled ( true );
}
void Rebuild::on_previewButton_clicked()
{
	if ( viewer.isEmpty() || IFILE.isEmpty() ) return;
	QProcess *vproc = new QProcess();
	vproc->start ( viewer+" \""+IFILE+"\"" );
	vproc->waitForFinished ( -1 );
}
void Rebuild::on_OKB_clicked()
{
	bool replace = false;
	QString EFILE,EFILE_1;
	if ( createRadio->isChecked() )
	{
		EFILE = QFileDialog::getSaveFileName ( this, tr ( "Save result as:" ), ladir, tr ( "PDF Files (*.pdf)" ) );
		if ( EFILE.isEmpty() ) return;
		if ( !EFILE.endsWith ( ".pdf", Qt::CaseInsensitive ) ) EFILE+=".pdf";
		QRegExp rx ( "(\\.|\\_|\\-|\\+|\\/|\\s|[A-Z]|[a-z]|[0-9])+" );
		if ( !rx.exactMatch ( EFILE ) )
		{
			QMessageBox::warning ( this, "",  tr ( "Due to pdftk limitations, result cannot be saved as %1.<br>It will be saved in temporary directory and then copied to %1" ).arg ( EFILE ) );
			int i=0;
			while ( QFile ( QDir().homePath() +"/.suslictk" +tr ( "/tmp_save_%1.pdf" ).arg ( i ) ).exists() ) i++;
			EFILE_1 = QDir().homePath() +"/.suslictk" +tr ( "/tmp_save_%1.pdf" ).arg ( i );
		}
		else EFILE_1 = EFILE;
	}
	else
	{
		qDebug() <<"IFILE "<<IFILE<<"IFILE_C "<<IFILE_C;
		replace = true;
		EFILE = IFILE;
		int i=0;
		while ( QFile ( QDir().homePath() +"/.suslictk" +tr ( "/tmp_save_%1.pdf" ).arg ( i ) ).exists() ) i++;
		EFILE_1 = QDir().homePath() +"/.suslictk" +tr ( "/tmp_save_%1.pdf" ).arg ( i );
	}
	if ( !EFILE.isEmpty() )
	{
		bool ok = true;
		QProcess *proc = new QProcess ( this );
		QString RUN = pdftk+" \""+IFILE_C+"\" cat ";
		for ( int i=0;i<PageList->count();i++ )
		{
			RUN+=PageList->item ( i )->text() +" ";
		}
		RUN+="output \""+EFILE_1+"\"";
		qDebug() <<RUN;
		proc->start ( RUN );
		emit _addPEc ( RUN );
		if ( !proc->waitForStarted()  || !proc->waitForFinished() ) {qDebug() <<"Failed to start/finish";}
		else
		{
			QString sOut = proc->readAllStandardOutput();
			sErr1 = proc->readAllStandardError();
			emit _addPE ( sOut+"<br>"+sErr1 );
			if ( sErr1.isEmpty() )
			{
				if(EFILE_1 == EFILE)	QMessageBox::information ( this, "", tr ( "Success! Output file generated and saved as<br>%1" ).arg ( EFILE ) );
				else
				{
					if(QFile(EFILE).exists() && !QFile(EFILE).remove())
					{
						QMessageBox::warning ( this, tr ( "Warning" ), tr ( "Cannot replace input file!<br>Created file is located here:<br>%1" ).arg ( EFILE_1 ) );
						ok = false;
					}
					else
					{
						if(!QFile().copy(EFILE_1, EFILE))
						{
							QMessageBox::warning ( this, tr ( "Warning" ), tr ( "Cannot replace input file!<br>Created file is located here:<br>%1" ).arg ( EFILE_1 ) );
							ok = false;
						}
						else
						{
							QMessageBox::information ( this, "", tr ( "Success! Output file generated and saved as<br>%1" ).arg ( EFILE ) );
							if(!QFile(EFILE_1).remove())	qDebug()<<"Rebuild: failed to remove tmp file";
						}
					}
				}
				if ( !viewer.isEmpty() && ok && QMessageBox::question ( this, tr ( "View result" ), tr ( "Do you want to view result in external viewer?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					proc->start ( viewer+" \""+EFILE+"\"" );
					proc->waitForFinished ( -1 );
				}
				if ( !closeCheck->isChecked() )
				{
					if ( EFILE != IFILE && QMessageBox::question ( this, "", tr ( "Work with new file?\n(Yes - new file, No - old file)" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
					{
						IFILE = EFILE;
						PageList->clear();
						if ( addFile() )
						{
							OKB->setEnabled ( true );
							groupBox->setEnabled ( true );
							groupBox_2->setEnabled ( true );
							ifileEdit->setText ( tr ( "%1 : %2 pages" ).arg ( IFILE.split ( "/", QString::SkipEmptyParts ).last() ).arg ( pageNum ) );
						}
						else
						{
							OKB->setEnabled ( false );
							groupBox->setEnabled ( false );
							groupBox_2->setEnabled ( false );
						}
						QApplication::restoreOverrideCursor();
					}
					else
					{
						if ( ok )
						{
							if ( addFile() )
							{
								OKB->setEnabled ( true );
								groupBox->setEnabled ( true );
								groupBox_2->setEnabled ( true );
								ifileEdit->setText ( tr ( "%1 : %2 pages" ).arg ( IFILE.split ( "/", QString::SkipEmptyParts ).last() ).arg ( pageNum ) );
							}
							else
							{
								OKB->setEnabled ( false );
								groupBox->setEnabled ( false );
								groupBox_2->setEnabled ( false );
							}
							QApplication::restoreOverrideCursor();
						}
					}
				}
			}
			else{QMessageBox::critical ( this, tr ( "Error" ), tr ( "Error occurred! Process output:<br>%1" ).arg ( sErr1 ) );reject();}
		}
	}
	if ( closeCheck->isChecked() ) accept();
}
bool Rebuild::addFile()
{
	QApplication::setOverrideCursor ( QCursor ( Qt::WaitCursor ) );
	QProcess *getpage = new QProcess ( this );
	bool passcorr = true;bool rename = false;
	bool change;
	IFILE_C = checkPath ( "rebuild", IFILE, "rebcp", this, &change, true );
	if ( IFILE_C.isEmpty() ) return false;
	QString ss = pdftk+" \""+IFILE_C+"\" dump_data output -";
	getpage->start ( ss );
	emit _addPEc ( ss );
	if ( !getpage->waitForStarted() ) {qDebug() <<"Could not start\n";return false;}
	if ( !getpage->waitForFinished() ) {qDebug() <<"Could not finish\n";return false;}
	getpage->closeWriteChannel();
	QString sNum = getpage->readAllStandardOutput();
	QString sErr = getpage->readAllStandardError();
	emit _addPE ( sNum+"<br>"+sErr );
	if ( !sErr.isEmpty() )
	{
		if ( sErr.contains ( "OWNER PASSWORD" ) )
		{
			bool cont = false;
			while ( !cont )
			{
				QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required for<br>%1<br>No/incorrect password given!" ).arg ( IFILE ) );
				if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
				{
					QString paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
					if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
					else
					{
						ss = pdftk+" \""+IFILE_C+"\" input_pw \""+paStr+"\" dump_data output -";
						getpage = new QProcess ( this );
						getpage->start ( ss );
						emit _addPEc ( ss );
						if ( !getpage->waitForStarted() ) {qDebug() <<"Could not start";qDebug() <<"Error";return false;}
						if ( !getpage->waitForFinished() ) {qDebug() <<"Could not finish";qDebug() <<"Error";return false;}
						getpage->closeWriteChannel();
						sErr = getpage->readAllStandardError();
						sNum = getpage->readAllStandardOutput();
						emit _addPE ( sNum+"<br>"+sErr );
						if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
						if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) )
						{
							cont = true;
							passcorr = false;
						}
						if ( sErr.isEmpty() )
						{
							cont = true;passcorr = true;
							getpage = new QProcess ( this );
							QString procSS  = pdftk+" \""+IFILE_C+"\" input_pw \""+paStr+"\" output \""+QDir().homePath() +"/.suslictk/tmp_reb_"+QFileInfo ( IFILE_C ).baseName() +"_decrypted.pdf\"";
							getpage->start ( procSS );
							emit _addPEc ( procSS );
							if ( !getpage->waitForStarted() ) {qDebug() <<"Error";return false;}
							if ( !getpage->waitForFinished() ) {qDebug() <<"Error";return false;}
							emit _addPE ( getpage->readAllStandardOutput() + "<br>" + getpage->readAllStandardError() );
							if ( getpage->exitCode() == 0 )
							{
								IFILE_C = QDir().homePath() +"/.suslictk/tmp_reb_"+QFileInfo ( IFILE_C ).baseName() +"_decrypted.pdf";
								rename = true;
							}
							else{passcorr = false;}
						}
					}
				}
				else{cont = true;passcorr = false;}
			}
		}
		else{{qDebug() <<"Error:\n"<<sErr;QMessageBox::critical ( this, tr ( "Error" ), tr ( "Error occurred! Maybe wrong file name?" ) );return false;}}
	}
	if ( passcorr )
	{
		if ( rename )
			QMessageBox::information ( this, tr ( "Attention!" ), tr ( "Selected file is encrypted and program will work with decrypted copy of this file, which has been saved as<br>%1<br>It can be deleted later by your request" ).arg ( IFILE_C ) );
		if ( sNum.contains ( "NumberOfPages" ) )
		{
			QStringList qsl = sNum.split ( "\n" ).filter ( "NumberOfPages" );
			QString Num;
			pageNum = qsl.last().split ( " " ).last().toInt();
			if ( pageNum<=0 ) {QMessageBox::critical ( this, tr ( "Error" ), tr ( "Unable to get information about file<br> %1 <br>Please choose another file" ).arg ( IFILE ) );qDebug() <<"Error";return false;}
		}
		else
		{
			QMessageBox::critical ( this, tr ( "Error" ), tr ( "Unable to get information about file<br> %1 <br>Please choose another file" ).arg ( IFILE ) );qDebug() <<"Error";return false;
		}
	}
	else{qDebug() <<"Error";return false;}
	QApplication::restoreOverrideCursor();
	return true;
}
Rebuild::~Rebuild() {destroy();}
