/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef REBUILD_H
#define REBUILD_H

#include "Page.h"
#include <QtGui/QRadioButton>
#include <QtGui/QGroupBox>
#include <QtGui/QLineEdit>
#include <QtGui/QListWidget>
#include <QProcess>
#include <QListWidgetItem>
#include <QTime>
#include "Check_impl.h"
#include <QDebug>
#include <QMenu>
#include <QAction>
#include <QInputDialog>
#include <QKeyEvent>
#include <QFileInfo>
#include <QToolButton>

class Rebuild: public QDialog
{
		Q_OBJECT
	public:
		Rebuild ( QWidget *parent = 0, Qt::WindowFlags f = Qt::Dialog, QString ifile = "", QString pdftkBin = "pdftk", QString viewerBin = "", QString bg = "", QString ldir = QDir().homePath() );
		~Rebuild();
		QString ladir;
		void retranslateUi();
	signals:
		void _addPEc(QString str);
		void _addPE(QString str);
	protected:
		void keyPressEvent(QKeyEvent *e);
	private slots:
		void on_rangeAdd_triggered();
		void on_pagesAdd_triggered();
		void on_downButton_clicked();
		void on_editButton_clicked();
		void on_remButton_clicked();
		void on_upButton_clicked();
		void onChoose(QString ifile = "");
		void on_previewButton_clicked();
		void on_OKB_clicked();
	private:
		bool addFile();
		QString IFILE, IFILE_C, sErr1, pdftk, viewer, bg;
		int pageNum;
		QVBoxLayout *verticalLayout_2;
		QGroupBox *groupBox;
		QHBoxLayout *horizontalLayout_4;
		QRadioButton *createRadio;
		QRadioButton *overRadio;
		QWidget *layoutWidget;
		QHBoxLayout *horizontalLayout_5;
		QListWidget *PageList;
		QGroupBox *groupBox_2;
		QVBoxLayout *verticalLayout;
		QPushButton *addButton;
		QPushButton *editButton;
		QPushButton *remButton;
		QPushButton *upButton;
		QPushButton *downButton;
		QToolButton *previewButton;
		QWidget *widget2;
		QHBoxLayout *horizontalLayout_2;
		QCheckBox *closeCheck;
		QHBoxLayout *horizontalLayout;
		QPushButton *CAB;
		QPushButton *OKB;
		QWidget *widget3;
		QHBoxLayout *horizontalLayout_3;
		QLabel *label;
		QLineEdit *ifileEdit;
		QToolButton *chooseButton;
		QMenu *addMenu;
		QAction *rangeAdd;
		QAction *pagesAdd;
};

#endif
