/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Rem.h"

Rem::Rem ( QWidget *parent, Qt::WindowFlags f )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}

	setObjectName ( QString::fromUtf8 ( "Rem" ) );
	resize ( 301, 315 );
	verticalLayout = new QVBoxLayout ( this );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	textBrowser = new QTextBrowser ( this );
	textBrowser->setObjectName ( QString::fromUtf8 ( "textBrowser" ) );

	verticalLayout->addWidget ( textBrowser );

	horizontalLayout = new QHBoxLayout();
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	saveButton = new QPushButton ( this );
	saveButton->setObjectName ( QString::fromUtf8 ( "saveButton" ) );

	horizontalLayout->addWidget ( saveButton );

	horizontalSpacer = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout->addItem ( horizontalSpacer );

	closeButton = new QPushButton ( this );
	closeButton->setObjectName ( QString::fromUtf8 ( "closeButton" ) );

	horizontalLayout->addWidget ( closeButton );


	verticalLayout->addLayout ( horizontalLayout );


	retranslateUi();

	connect ( saveButton, SIGNAL ( clicked() ), this, SLOT ( accept() ) );
	connect ( closeButton, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
}
void Rem::retranslateUi()
{
	setWindowTitle ( QApplication::translate ( "Rem", "Remove files?" , 0, QApplication::UnicodeUTF8 ) );
	saveButton->setText ( QApplication::translate ( "Rem", "&Yes", 0, QApplication::UnicodeUTF8 ) );
	closeButton->setText ( QApplication::translate ( "Rem", "&No", 0, QApplication::UnicodeUTF8 ) );
}
void Rem::INIT()
{
	textBrowser->setHtml ("<html><body><ul><uh>Files to remove:</uh>");
	for(int i=0;i<remStrL.count();i++)
	{
		textBrowser->setHtml(textBrowser->toHtml()+"<li>"+remStrL[i]);
	}
	textBrowser->setHtml(textBrowser->toHtml()+"</ul></body></html>");
	adjustSize();
}
Rem::~Rem()
{
	destroy();
}
