/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "suslictk.h"

void SuslicTk::onRemTemp ( bool autom, QString id )
{
	QStringList remL = homePDF->entryList ( QStringList() <<"*.pdf",QDir::Files, QDir::Name );
	if ( !remL.isEmpty() )
	{
		if ( autom )
		{
			for ( int i=0;i<remL.count();i++ )
			{
				QFile *tmpf = new QFile ( homePDF->absolutePath() +"/"+remL[i] );
				if ( id.isEmpty() ) { if ( !tmpf->remove() ) {qDebug() <<"failed to remove "<<remL[i];}
					else{qDebug() <<"removed "<<remL[i];}}
				else
				{
					if ( remL[i].contains ( id ) ) { if ( !tmpf->remove() ) {qDebug() <<"failed to remove "<<remL[i];}
						else{qDebug() <<"removed "<<remL[i];}}
				}
			}
		}
		else
		{
			SDlg *seld = new SDlg ( this, Qt::Tool, &remL , "check", tr ( "Files to delete:" ) );
			if ( seld->exec() == 1 )
			{
				for ( int i=0;i<remL.count();i++ )
				{
					QFile *tmpf = new QFile ( homePDF->absolutePath() +"/"+remL[i] );
					if ( !tmpf->remove() ) {TE->setText ( TE->toHtml() +tr ( "<br>Failed to delete<br>" ) +remL[i] );}
					else{TE->setText ( TE->toHtml() +tr ( "<br>%1 successfully deleted" ).arg ( remL[i] ) );}
				}
			}
		}
	}
	else
	{
		if ( !autom ) QMessageBox::information ( this, tr("PdfTk-QGUI"), tr ( "No temporary files to delete!" ) );
	}
	remL = QDir ( homePDF->absolutePath() +"/temp" ).entryList ( QStringList() <<"*", QDir::Files, QDir::Name );
	for ( int i=0;i<remL.count();i++ )
	{
		QFile *tmpf = new QFile ( homePDF->absolutePath() +"/temp/"+remL[i] );
		if ( id.isEmpty() )
		{
			if ( !tmpf->remove() ) {qDebug() <<"failed to remove "<<remL[i];}
			else{qDebug() <<"removed "<<remL[i];}
		}
		else
		{
			if ( remL[i].contains ( id ) ) { if ( !tmpf->remove() ) {qDebug() <<"failed to remove "<<remL[i];}
				else{qDebug() <<"removed "<<remL[i];}}
		}
	}
}
