/***************************************************************************
 * Any complaints or wishes please mail to suslic-2012@rambler.ru *
 * *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or *
 * (at your option) any later version. *
 * *
 * This program is distributed in the hope that it will be useful, *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the *
 * GNU General Public License for more details. *
 * *
 * You should have received a copy of the GNU General Public License *
 * along with this program; if not, write to the *
 * Free Software Foundation, Inc., *
 * 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. *
 ***************************************************************************/

#ifndef SELRANGE_H
#define SELRANGE_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QDialogButtonBox>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QVBoxLayout>
#include <QStringList>
#include <QDebug>

class SelRange: public QDialog
{
		Q_OBJECT

	public:
		SelRange ( QWidget *parent, Qt::WindowFlags f, int numpages, QString bg );
		~SelRange();
		int from, to;
	private slots:
		void onFrom ( int i );
		void onTo ( int i );
	private:
		QVBoxLayout *verticalLayout;
		QHBoxLayout *horizontalLayout;
		QLabel *label, *label_h;
		QComboBox *comboBox;
		QLabel *label_2;
		QComboBox *comboBox_2;
		QDialogButtonBox *buttonBox;
};

#endif
