/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef SELECTFILES_H
#define SELECTFILES_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QDialog>
#include <QtGui/QHBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QComboBox>
#include <QtGui/QVBoxLayout>
#include <QtGui/QWidget>
#include <QtGui/QSpacerItem>
#include <QStringList>
#include <QScrollArea>
#include <QDebug>

class SelectFiles: public QDialog
{
		Q_OBJECT
	public:
		SelectFiles ( QWidget* parent = 0, Qt::WindowFlags f = Qt::Dialog, QStringList *list = NULL ) ;
		~SelectFiles();
		void retranslateUi();
		int comboIndex;
	private slots:
		void onOk();
		void onNone();
		void onAll();
	private:
		QStringList* list_cp;
		QWidget *layoutWidget, *layoutWidget2, *scrollWidget;
		QComboBox *comboBox;
		QScrollArea *scrollArea;
		QVBoxLayout *scrollLayout;
		QHBoxLayout *horizontalLayout, *horizontalLayout2;
		QPushButton *CAB;
		QPushButton *OKB;
		QPushButton *allB;
		QPushButton *noneB;
		QVBoxLayout *verticalLayout;
    		QSpacerItem *horizontalSpacer, *horizontalSpacer_2;
		QLabel *label;
		QCheckBox* *checkBoxes;

};

#endif
