/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef BACKSEL_H
#define BACKSEL_H

#include <QtGui/QApplication>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QGroupBox>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
//#include <QStringList>
class BackSel: public QDialog
{
		Q_OBJECT
	public:
		BackSel ( QWidget* parent = 0, Qt::WindowFlags f = Qt::Dialog, QStringList* files  = NULL, int *index = NULL );
		~BackSel();
	private slots:
		void onOK();
	private:
		QStringList *dispList;
		QWidget *layoutWidget;
		QHBoxLayout *horizontalLayout;
		QPushButton *CAB;
		QPushButton *OKB;
		QGroupBox *groupBox;
		QWidget *widget;
		QGridLayout *gridLayout;
		QLabel *label;
		QComboBox *catCombo;
		QLabel *label_2;
		QComboBox *burCombo;
		QLabel *label_3;
		QComboBox *attCombo;
		QLabel *label_4;
		QComboBox *encrCombo;
		QLabel *label_5;
		QComboBox *reportCombo;
};

#endif
