/**************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Cat.h"

Cat::Cat ( QWidget *parent, Qt::WindowFlags f, QStringList ifiles, QString pdftk , QString bg, QString LastDir )
{
	curRow = -1;
	lastCatDir = LastDir;
	qDebug() <<"cat lastdir "<<lastCatDir;
	pdftkBinC  = pdftk;
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}

	setObjectName ( QString::fromUtf8 ( "Cat" ) );
	resize ( 547, 594 );
	verticalLayout = new QVBoxLayout ( this );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	horizontalLayout_7 = new QHBoxLayout();
	horizontalLayout_7->setObjectName ( QString::fromUtf8 ( "horizontalLayout_7" ) );
	groupBox_8 = new QGroupBox ( this );
	groupBox_8->setObjectName ( QString::fromUtf8 ( "groupBox_8" ) );
	horizontalLayout = new QHBoxLayout ( groupBox_8 );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );
	horizontalLayout->setContentsMargins ( 1, 1, 1,1 );
	add_button = new QPushButton ( groupBox_8 );
	add_button->setObjectName ( QString::fromUtf8 ( "add_button" ) );

	horizontalLayout->addWidget ( add_button );

	all_button = new QPushButton ( groupBox_8 );
	all_button->setObjectName ( QString::fromUtf8 ( "all_button" ) );

	horizontalLayout->addWidget ( all_button );

	remove_button = new QPushButton ( groupBox_8 );
	remove_button->setObjectName ( QString::fromUtf8 ( "remove_button" ) );

	horizontalLayout->addWidget ( remove_button );


	horizontalLayout_7->addWidget ( groupBox_8 );

	horizontalSpacer_2 = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout_7->addItem ( horizontalSpacer_2 );

	groupBox_3 = new QGroupBox ( this );
	groupBox_3->setObjectName ( QString::fromUtf8 ( "groupBox_3" ) );
	horizontalLayout_4 = new QHBoxLayout ( groupBox_3 );
	horizontalLayout_4->setObjectName ( QString::fromUtf8 ( "horizontalLayout_4" ) );
	horizontalLayout_4->setContentsMargins ( 1, 1, 1,1 );
	UpUp_button = new QPushButton ( groupBox_3 );
	UpUp_button->setObjectName ( QString::fromUtf8 ( "UpUp_button" ) );

	horizontalLayout_4->addWidget ( UpUp_button );

	Up_button = new QPushButton ( groupBox_3 );
	Up_button->setObjectName ( QString::fromUtf8 ( "Up_button" ) );

	horizontalLayout_4->addWidget ( Up_button );

	Down_button = new QPushButton ( groupBox_3 );
	Down_button->setObjectName ( QString::fromUtf8 ( "Down_button" ) );

	horizontalLayout_4->addWidget ( Down_button );

	DownDown_button = new QPushButton ( groupBox_3 );
	DownDown_button->setObjectName ( QString::fromUtf8 ( "DownDown_button" ) );

	horizontalLayout_4->addWidget ( DownDown_button );


	horizontalLayout_7->addWidget ( groupBox_3 );


	verticalLayout->addLayout ( horizontalLayout_7 );

	FileList = new QListWidget ( this );
	FileList->setObjectName ( QString::fromUtf8 ( "FileList" ) );

	verticalLayout->addWidget ( FileList );

	groupBox_2 = new QGroupBox ( this );
	groupBox_2->setObjectName ( QString::fromUtf8 ( "groupBox_2" ) );
	horizontalLayout_2 = new QHBoxLayout ( groupBox_2 );
	horizontalLayout_2->setObjectName ( QString::fromUtf8 ( "horizontalLayout_2" ) );
	groupBox_4 = new QGroupBox ( groupBox_2 );
	groupBox_4->setObjectName ( QString::fromUtf8 ( "groupBox_4" ) );
	gridLayout_2 = new QGridLayout ( groupBox_4 );
	gridLayout_2->setObjectName ( QString::fromUtf8 ( "gridLayout_2" ) );
	gridLayout_2->setContentsMargins ( 1, 1, 1,1 );
	all_radio = new QRadioButton ( groupBox_4 );
	all_radio->setObjectName ( QString::fromUtf8 ( "all_radio" ) );

	gridLayout_2->addWidget ( all_radio, 0, 0, 1, 1 );

	horizontalSpacer = new QSpacerItem ( 82, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	gridLayout_2->addItem ( horizontalSpacer, 0, 1, 1, 1 );

	range_radio = new QRadioButton ( groupBox_4 );
	range_radio->setObjectName ( QString::fromUtf8 ( "range_radio" ) );

	gridLayout_2->addWidget ( range_radio, 1, 0, 1, 1 );

	select_radio = new QRadioButton ( groupBox_4 );
	select_radio->setObjectName ( QString::fromUtf8 ( "select_radio" ) );

	gridLayout_2->addWidget ( select_radio, 2, 0, 1, 1 );

	rangeEdit = new QPushButton ( groupBox_4 );
	rangeEdit->setObjectName ( QString::fromUtf8 ( "rangeEdit" ) );

	gridLayout_2->addWidget ( rangeEdit, 1, 1, 1, 1 );

	selectEdit = new QPushButton ( groupBox_4 );
	selectEdit->setObjectName ( QString::fromUtf8 ( "selectEdit" ) );

	gridLayout_2->addWidget ( selectEdit, 2, 1, 1, 1 );


	horizontalLayout_2->addWidget ( groupBox_4 );

	horizontalSpacer_4 = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
	horizontalLayout_2->addItem(horizontalSpacer_4);

	groupBox_6 = new QGroupBox ( groupBox_2 );
	groupBox_6->setObjectName ( QString::fromUtf8 ( "groupBox_6" ) );
	gridLayout_4 = new QGridLayout ( groupBox_6 );
	gridLayout_4->setObjectName ( QString::fromUtf8 ( "gridLayout_4" ) );
	gridLayout_4->setContentsMargins ( 1, 1, 1,1 );
	label_5 = new QLabel ( groupBox_6 );
	label_5->setObjectName ( QString::fromUtf8 ( "label_5" ) );

	gridLayout_4->addWidget ( label_5, 0, 0, 1, 1 );

	odd_check = new QCheckBox ( groupBox_6 );
	odd_check->setObjectName ( QString::fromUtf8 ( "odd_check" ) );

	gridLayout_4->addWidget ( odd_check, 0, 1, 1, 1 );

	even_check = new QCheckBox ( groupBox_6 );
	even_check->setObjectName ( QString::fromUtf8 ( "even_check" ) );

	gridLayout_4->addWidget ( even_check, 0, 2, 1, 1 );

	label_6 = new QLabel ( groupBox_6 );
	label_6->setObjectName ( QString::fromUtf8 ( "label_6" ) );

	gridLayout_4->addWidget ( label_6, 1, 0, 1, 1 );

	all_combo = new QComboBox ( groupBox_6 );
	all_combo->setObjectName ( QString::fromUtf8 ( "all_combo" ) );

	gridLayout_4->addWidget ( all_combo, 1, 1, 1, 1 );

	help_button = new QPushButton ( groupBox_6 );
	help_button->setObjectName ( QString::fromUtf8 ( "help_button" ) );

	gridLayout_4->addWidget ( help_button, 1, 2, 1, 1 );


	horizontalLayout_2->addWidget ( groupBox_6 );


	verticalLayout->addWidget ( groupBox_2 );

	horizontalLayout_3 = new QHBoxLayout();
	horizontalLayout_3->setObjectName ( QString::fromUtf8 ( "horizontalLayout_3" ) );
	groupBox_7 = new QGroupBox ( this );
	groupBox_7->setObjectName ( QString::fromUtf8 ( "groupBox_7" ) );
	gridLayout_3 = new QGridLayout ( groupBox_7 );
	gridLayout_3->setObjectName ( QString::fromUtf8 ( "gridLayout_3" ) );
	label_3 = new QCheckBox ( groupBox_7 );
	label_3->setObjectName ( QString::fromUtf8 ( "label_3" ) );

	gridLayout_3->addWidget ( label_3, 0, 0, 1, 1 );

	userEdit = new QLineEdit ( groupBox_7 );
	userEdit->setObjectName ( QString::fromUtf8 ( "userEdit" ) );

	gridLayout_3->addWidget ( userEdit, 0, 1, 1, 1 );

	label_4 = new QCheckBox ( groupBox_7 );
	label_4->setObjectName ( QString::fromUtf8 ( "label_4" ) );

	gridLayout_3->addWidget ( label_4, 1, 0, 1, 1 );

	ownerEdit = new QLineEdit ( groupBox_7 );
	ownerEdit->setObjectName ( QString::fromUtf8 ( "ownerEdit" ) );

	gridLayout_3->addWidget ( ownerEdit, 1, 1, 1, 1 );


	horizontalLayout_3->addWidget ( groupBox_7 );

	groupBox = new QGroupBox ( this );
	groupBox->setObjectName ( QString::fromUtf8 ( "groupBox" ) );
	QSizePolicy sizePolicy ( QSizePolicy::Expanding, QSizePolicy::Preferred );
	sizePolicy.setHorizontalStretch ( 0 );
	sizePolicy.setVerticalStretch ( 0 );
	sizePolicy.setHeightForWidth ( groupBox->sizePolicy().hasHeightForWidth() );
	groupBox->setSizePolicy ( sizePolicy );
	gridLayout = new QGridLayout ( groupBox );
	gridLayout->setObjectName ( QString::fromUtf8 ( "gridLayout" ) );
	label = new QLabel ( groupBox );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	gridLayout->addWidget ( label, 0, 0, 1, 1 );

	nameLabel = new QLabel ( groupBox );
	nameLabel->setObjectName ( QString::fromUtf8 ( "nameLabel" ) );

	gridLayout->addWidget ( nameLabel, 0, 1, 1, 1 );

	label_2 = new QLabel ( groupBox );
	label_2->setObjectName ( QString::fromUtf8 ( "label_2" ) );

	gridLayout->addWidget ( label_2, 1, 0, 1, 1 );

	pageLabel = new QLabel ( groupBox );
	pageLabel->setObjectName ( QString::fromUtf8 ( "pageLabel" ) );

	gridLayout->addWidget ( pageLabel, 1, 1, 1, 1 );


	horizontalLayout_3->addWidget ( groupBox );


	verticalLayout->addLayout ( horizontalLayout_3 );

	horizontalLayout_5 = new QHBoxLayout();
	horizontalLayout_5->setObjectName ( QString::fromUtf8 ( "horizontalLayout_5" ) );
	horizontalSpacer_3 = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

	horizontalLayout_5->addItem ( horizontalSpacer_3 );

	CAB = new QPushButton ( this );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout_5->addWidget ( CAB );

	OKB = new QPushButton ( this );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout_5->addWidget ( OKB );


	verticalLayout->addLayout ( horizontalLayout_5 );
	/////////////////////////////////////////////////////////////////////////////////

	backg = bg;
	if ( !bg.isEmpty() ) {setStyleSheet ( tr ( "QDialog{background: url(%1);}" ).arg ( bg ) );}
	this->setWindowIcon ( QIcon ( ":/cat" ) );
	OKB->setEnabled ( false );
	alertS = false;
	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( onOK() ) );
	connect ( label_3, SIGNAL ( clicked ( bool ) ), this, SLOT ( onUserEncrypt ( bool ) ) );
	connect ( label_4, SIGNAL ( clicked ( bool ) ), this, SLOT ( onOwnerEncrypt ( bool ) ) );
	userEdit->setEnabled ( false );
	ownerEdit->setEnabled ( false );
	connect ( selectEdit, SIGNAL ( clicked() ), this, SLOT ( onSelectE () ) );
	connect ( rangeEdit, SIGNAL ( clicked() ), this, SLOT ( onRangeE () ) );
	remove_button->setIcon ( QIcon ( ":/remove" ) );
	connect ( remove_button, SIGNAL ( clicked() ), this, SLOT ( onRemove() ) );
	Up_button->setIcon ( QIcon ( ":/up" ) );
	Up_button->setToolTip ( tr ( "Up" ) );
	connect ( Up_button, SIGNAL ( clicked() ), this, SLOT ( onUp() ) );
	Down_button->setIcon ( QIcon ( ":/down" ) );
	Down_button->setToolTip ( tr ( "Down" ) );
	connect ( Down_button, SIGNAL ( clicked() ), this, SLOT ( onDown() ) );
	UpUp_button->setIcon ( QIcon ( ":/upup" ) );
	UpUp_button->setToolTip ( tr ( "Top" ) );
	connect ( UpUp_button, SIGNAL ( clicked() ), this, SLOT ( onUpUp() ) );
	DownDown_button->setIcon ( QIcon ( ":/downdown" ) );
	DownDown_button->setToolTip ( tr ( "Bottom" ) );
	connect ( DownDown_button, SIGNAL ( clicked() ), this, SLOT ( onDownDown() ) );
	add_button->setIcon ( QIcon ( ":/add" ) );
	connect ( add_button, SIGNAL ( clicked() ), this, SLOT ( onAdd() ) );
	all_button->setIcon ( QIcon ( ":/addall" ) );
	connect ( all_button, SIGNAL ( clicked() ), this, SLOT ( onAllCat() ) );
	help_button->setIcon ( QIcon ( qApp->style()->standardIcon(QStyle::SP_DialogHelpButton) ) );
	connect ( help_button, SIGNAL ( clicked() ), this, SLOT ( onHelp() ) );
	connect ( odd_check, SIGNAL ( clicked ( bool ) ), this, SLOT ( onOdd ( bool ) ) );
	connect ( even_check, SIGNAL ( clicked ( bool ) ), this, SLOT ( onEven ( bool ) ) );
	connect ( all_combo, SIGNAL ( activated ( int ) ), this, SLOT ( onRotC ( int ) ) );
	this->move ( 300, 150 );
	homeP = QDir().homePath();
	encr = "";
	connect ( FileList, SIGNAL ( currentRowChanged ( int ) ), this , SLOT ( onList ( int ) ) );
	connect ( all_radio, SIGNAL ( clicked ( bool ) ), this, SLOT ( onAllR ( bool ) ) );
	connect ( range_radio, SIGNAL ( clicked ( bool ) ), this, SLOT ( onRangeR ( bool ) ) );
	connect ( select_radio, SIGNAL ( clicked ( bool ) ), this, SLOT ( onSelectR ( bool ) ) );
////////////////////////////
	rangeEdit->setEnabled ( false );
	selectEdit->setEnabled ( false );
	selectEdit->setText ( tr ( "Change" ) );

	retranslateUi();

	adjustSize();
	
	if(ifiles.count() > 0)
	{
		tmpList = ifiles;
		onAdd(false);
	}
}
void Cat::retranslateUi()
{
	setWindowTitle ( QApplication::translate ( "Cat", "Cat", 0, QApplication::UnicodeUTF8 ) );
	groupBox->setTitle ( QApplication::translate ( "Cat", "File Info", 0, QApplication::UnicodeUTF8 ) );
	label->setText ( QApplication::translate ( "Cat", "Name:", 0, QApplication::UnicodeUTF8 ) );
	nameLabel->setText ( QApplication::translate ( "Cat", "-------", 0, QApplication::UnicodeUTF8 ) );
	label_2->setText ( QApplication::translate ( "Cat", "Pages:", 0, QApplication::UnicodeUTF8 ) );
	pageLabel->setText ( QApplication::translate ( "Cat", "-------", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setTitle ( QApplication::translate ( "Cat", "Properties", 0, QApplication::UnicodeUTF8 ) );
	groupBox_2->setEnabled ( false );
	groupBox_4->setTitle ( QApplication::translate ( "Cat", "Pages:", 0, QApplication::UnicodeUTF8 ) );
	all_radio->setText ( QApplication::translate ( "Cat", "All pages", 0, QApplication::UnicodeUTF8 ) );
	range_radio->setText ( QApplication::translate ( "Cat", "Page Range", 0, QApplication::UnicodeUTF8 ) );
	select_radio->setText ( QApplication::translate ( "Cat", "Selected pages", 0, QApplication::UnicodeUTF8 ) );
	//groupBox_5->setTitle ( QApplication::translate ( "Cat", "Rotation:", 0, QApplication::UnicodeUTF8 ) );
	all_combo->clear();
	all_combo->insertItems ( 0, QStringList()
	                         << QApplication::translate ( "Cat", "None", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Cat", "North", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Cat", "East", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Cat", "South", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Cat", "West", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Cat", "Rotate +90", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Cat", "Rotate -90", 0, QApplication::UnicodeUTF8 )
	                         << QApplication::translate ( "Cat", "Rotate 180", 0, QApplication::UnicodeUTF8 )
	                       );
	help_button->setToolTip ( QApplication::translate ( "Cat", " Help", 0, QApplication::UnicodeUTF8 ) );
	//groupBox_6->setTitle ( QApplication::translate ( "Cat", "Qualifier", 0, QApplication::UnicodeUTF8 ) );
	odd_check->setText ( QApplication::translate ( "Cat", "Odd", 0, QApplication::UnicodeUTF8 ) );
	even_check->setText ( QApplication::translate ( "Cat", "Even", 0, QApplication::UnicodeUTF8 ) );
	groupBox_3->setTitle ( QApplication::translate ( "Cat", "Sort List:", 0, QApplication::UnicodeUTF8 ) );
	Up_button->setToolTip ( QApplication::translate ( "Cat", "Up", 0, QApplication::UnicodeUTF8 ) );
	Down_button->setToolTip ( QApplication::translate ( "Cat", "Down", 0, QApplication::UnicodeUTF8 ) );
	add_button->setToolTip ( QApplication::translate ( "Cat", "Add File(s)", 0, QApplication::UnicodeUTF8 ) );
	all_button->setToolTip ( QApplication::translate ( "Cat", "Add all PDF files<br>from a directory", 0, QApplication::UnicodeUTF8 ) );
	remove_button->setToolTip ( QApplication::translate ( "Cat", "Remove selected item", 0, QApplication::UnicodeUTF8 ) );
	groupBox_7->setTitle ( QApplication::translate ( "Cat", "Encrypt output", 0, QApplication::UnicodeUTF8 ) );
	groupBox_7->setEnabled ( false );
	groupBox_6->setTitle(QApplication::translate("Cat", "Other:", 0, QApplication::UnicodeUTF8));
	label_3->setText ( QApplication::translate ( "Cat", "&User password:", 0, QApplication::UnicodeUTF8 ) );
	label_4->setText ( QApplication::translate ( "Cat", "&Owner password:", 0, QApplication::UnicodeUTF8 ) );
	label_6->setText ( QApplication::translate ( "Cat", "Rotation:", 0, QApplication::UnicodeUTF8 ) );
	label_5->setText ( QApplication::translate ( "Cat", "Qualifier:", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "Cat", "&OK", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "Cat", "Ca&ncel", 0, QApplication::UnicodeUTF8 ) );
	groupBox_8->setTitle ( QApplication::translate ( "Cat", "Manage list:", 0, QApplication::UnicodeUTF8 ) );
	setWhatsThis ( tr ( "Press:<br><b>A</b> to add files<br><b>R</b> to remove file<br><b>F</b> to add all files<br>  from a directory<br><b>U</b> to move selected item up<br><b>D</b> to move selected item down" ) );
}
void Cat::keyPressEvent ( QKeyEvent *event )
{
	if ( event->key() == Qt::Key_A ) {onAdd();}
	if ( event->key() == Qt::Key_R ) {onRemove();}
	if ( event->key() == Qt::Key_V ) {onCheck();}
	if ( event->key() == Qt::Key_H ) {onHelp();}
	if ( event->key() == Qt::Key_F ) {onAllCat();}
	if ( event->key() == Qt::Key_O ) {onOK();}
	//if ( event->key() == Qt::Key_Escape || event->key() == Qt::Key_N ) {onCheck();}
	if ( event->key() == Qt::Key_U ) {onUp();}
	if ( event->key() == Qt::Key_D ) {onDown();}
}
void Cat::onCheck()
{
	QString STR = "PageIFRange:";
	for ( int i=0;i<PageIFRange.count();i++ )
	{
		STR+=tr ( "<br>PageIFRange[%1] = %2" ).arg ( i ).arg ( PageIFRange[i] );
	}
	qDebug() <<STR<<curRow;
}
void Cat::onList ( int NUMB )
{
	if ( NUMB<0 )
	{
		groupBox_2->setEnabled ( false );
		return;
	}
	groupBox_2->setEnabled ( true );
	nameLabel->setText ( PDFFiles[NUMB].split ( "/" ).last().split ( "." ).first() );
	pageLabel->setText ( PageNum[NUMB] );
	//qDebug()<<"PageRotation["<<NUMB<<"] = "<<PageRotation[NUMB] ;
	if ( PageRotation[NUMB] == "none" ) {all_combo->setCurrentIndex ( 0 );}
	if ( PageRotation[NUMB] == "N" ) {all_combo->setCurrentIndex ( 1 );}
	if ( PageRotation[NUMB] == "E" ) {all_combo->setCurrentIndex ( 2 );}
	if ( PageRotation[NUMB] == "S" ) {all_combo->setCurrentIndex ( 3 );}
	if ( PageRotation[NUMB] == "W" ) {all_combo->setCurrentIndex ( 4 );}
	if ( PageRotation[NUMB] == "R" ) {all_combo->setCurrentIndex ( 5 );}
	if ( PageRotation[NUMB] == "L" ) {all_combo->setCurrentIndex ( 6 );}
	if ( PageRotation[NUMB] == "D" ) {all_combo->setCurrentIndex ( 7 );}
	if ( PageQualifier[NUMB] == "none" ) {odd_check->setChecked ( false );even_check->setChecked ( false );}
	if ( PageQualifier[NUMB] == "odd" ) {odd_check->setChecked ( true );even_check->setChecked ( false );}
	if ( PageQualifier[NUMB] == "even" ) {odd_check->setChecked ( false );even_check->setChecked ( true );}
	if ( PageIFRange[NUMB] == "all" )
	{
		all_radio->setChecked ( true );
		range_radio->setChecked ( false );
		select_radio->setChecked ( false );
		rangeEdit->setEnabled ( false );
		selectEdit->setEnabled ( false );
		rangeEdit->setText ( "" );
	}
	if ( PageIFRange[NUMB] == "range" )
	{
		all_radio->setChecked ( false );
		range_radio->setChecked ( true );
		select_radio->setChecked ( false );
		selectEdit->setEnabled ( false );
		rangeEdit->setEnabled ( true );
		rangeEdit->setText ( PageRange[NUMB] );
		rangeEdit->setText ( PageRange[NUMB] );
	}
	if ( PageIFRange[NUMB] == "select" )
	{
		all_radio->setChecked ( false );
		range_radio->setChecked ( false );
		select_radio->setChecked ( true );
		selectEdit->setEnabled ( true );
		rangeEdit->setEnabled ( false );
		rangeEdit->setText ( "" );
		selectEdit->setToolTip ( PageSelect[NUMB] );
	}
	curRow = NUMB;
}
void Cat::onAllR ( bool check )
{
	if ( check )
	{
		int num = FileList->currentRow();
		if ( num>=0 )
		{
			PageIFRange[num] = "all";
			PageRange[num] = "none";
			PageSelect[num] = "none";
			rangeEdit->setEnabled ( false );selectEdit->setEnabled ( false );
		}
	}
}
void Cat::onRangeR ( bool check )
{
//Range must be specified in the following way:<br> 1-5 or 4-2<br><b>Order matters!!</b>
	if ( check && curRow>=0 )
	{
		all_radio->setChecked ( false );
		select_radio->setChecked ( false );
		selectEdit->setEnabled ( false );
		rangeEdit->setEnabled ( true );
		PageIFRange[curRow] = "range";
		PageRange[curRow] = "1-end";
		rangeEdit->setText ( "1-end" );
		PageSelect[curRow] = "none";
		onRangeE();
	}
}
void Cat::onSelectR ( bool check )
{
	if ( check && curRow>=0 )
	{
		all_radio->setChecked ( false );
		range_radio->setChecked ( false );
		if ( !alertS )
		{
			QMessageBox::information ( this, tr ( "Tip:" ), tr ( "Pages must be specified in the following way:<br> 1 5 6 2 1 etc.<br><b>Order matters!! Spaces between pages are mandatory!<br>When 'Select Range' is selected, qualifiers will be ignored!</b><br>Of course, max page must be less than number of pages in the document!" ) );alertS = true;
		}
		selectEdit->setEnabled ( true );
		rangeEdit->setEnabled ( false );
		PageIFRange[curRow] = "select";
		PageRange[curRow] = "none";
		selectEdit->setToolTip ( "1" );
		PageSelect[curRow] = "1";
		onSelectE();
	}
}
void Cat::onRotC ( int index )
{
	if ( curRow>=0 )
	{
		if ( index == 0 ) {PageRotation[curRow] = "none";}
		if ( index == 1 ) {PageRotation[curRow] = "N";}
		if ( index == 2 ) {PageRotation[curRow] = "E";}
		if ( index == 3 ) {PageRotation[curRow] = "S";}
		if ( index == 4 ) {PageRotation[curRow] = "W";}
		if ( index == 5 ) {PageRotation[curRow] = "R";}
		if ( index == 6 ) {PageRotation[curRow] = "L";}
		if ( index == 7 ) {PageRotation[curRow] = "D";}
	}
}
void Cat::onHelp()
{
	QMessageBox::information ( this, tr ( "Help" ), tr ( "Each option sets the page rotation as follows (in degrees):<br> North: 0<br> East: 90<br> South: 180<br> West: 270<br> Rotate +90, -90, 180 make relative rotations." ) );
}
void Cat::onOdd ( bool check )
{
	if ( check && curRow>=0 )
	{
		PageQualifier[curRow] = "odd";
		even_check->setChecked ( false );

	}
}
void Cat::onEven ( bool check )
{
	if ( check && curRow>=0 )
	{
		PageQualifier[curRow] = "even";
		odd_check->setChecked ( false );
	}
}
void Cat::onUp()
{
	int NUMB = FileList->currentRow();
	qDebug() <<"NUMB = "<<NUMB;
	if ( NUMB>0 )
	{
		QListWidgetItem ITEM = * ( FileList->item ( NUMB ) );
		* ( FileList->item ( NUMB ) ) = * ( FileList->item ( NUMB-1 ) );
		* ( FileList->item ( NUMB-1 ) ) = ITEM;
		FileList->setCurrentRow ( NUMB-1 );
		PDFFiles.move ( NUMB, NUMB-1 );
		PageIFRange.move ( NUMB, NUMB-1 );
		PageRange.move ( NUMB, NUMB-1 );
		PageSelect.move ( NUMB, NUMB-1 );
		PageNum.move ( NUMB, NUMB-1 );
		PageRotation.move ( NUMB, NUMB-1 );
		PageQualifier.move ( NUMB, NUMB-1 );
		onList ( NUMB-1 );
	}
}
void Cat::onUpUp()
{
	int NUMB = FileList->currentRow();
	qDebug() <<"NUMB = "<<NUMB;
	if ( NUMB>0 )
	{
		QListWidgetItem* ITEM = ( FileList->item ( NUMB ) );
		FileList->takeItem ( NUMB );
		FileList->insertItem ( 0, ITEM );
		FileList->setCurrentRow ( 0 );
		PDFFiles.move ( NUMB, 0 );
		PageIFRange.move ( NUMB, 0 );
		PageRange.move ( NUMB, 0 );
		PageSelect.move ( NUMB, 0 );
		PageNum.move ( NUMB, 0 );
		PageRotation.move ( NUMB, 0 );
		PageQualifier.move ( NUMB, 0 );
		FileList->update();
		onList ( 0 );
	}
}
void Cat::onDown()
{
	int NUMB = FileList->currentRow();
	qDebug() <<"NUMB = "<<NUMB;
	if ( NUMB>=0 && NUMB< ( FileList->count()-1 ) )
	{
		QListWidgetItem ITEM = * ( FileList->item ( NUMB ) );
		* ( FileList->item ( NUMB ) ) = * ( FileList->item ( NUMB+1 ) );
		* ( FileList->item ( NUMB+1 ) ) = ITEM;
		FileList->setCurrentRow ( NUMB+1 );
		PDFFiles.move ( NUMB, NUMB+1 );
		PageIFRange.move ( NUMB, NUMB+1 );
		PageRange.move ( NUMB, NUMB+1 );
		PageSelect.move ( NUMB, NUMB+1 );
		PageNum.move ( NUMB, NUMB+1 );
		PageRotation.move ( NUMB, NUMB+1 );
		PageQualifier.move ( NUMB, NUMB+1 );
		onList ( NUMB+1 );
	}
}
void Cat::onDownDown()
{
	int NUMB = FileList->currentRow();
	qDebug() <<"NUMB = "<<NUMB;
	int END = FileList->count()-1;
	if ( NUMB>=0 && NUMB< ( END ) )
	{
		QString text = FileList->item ( NUMB )->text();
		//for(int i=NUMB;i<END;i++) * ( FileList->item ( i ) ) = * ( FileList->item ( i+1 ) );
		FileList->takeItem ( NUMB );
		FileList->addItem ( text );
		//* ( FileList->item ( END ) ) = ITEM;
		FileList->setCurrentRow ( END );
		PDFFiles.move ( NUMB, END );
		PageIFRange.move ( NUMB, END );
		PageRange.move ( NUMB, END );
		PageSelect.move ( NUMB, END );
		PageNum.move ( NUMB, END );
		PageRotation.move ( NUMB, END );
		PageQualifier.move ( NUMB, END );
		FileList->update();
		onList ( END );
	}
}
void Cat::onAdd ( bool ask )
{
	QStringList files;
	files.clear();
	if ( ask )
	{
		files = QFileDialog::getOpenFileNames ( this, tr ( "Select files to catenate" ),lastCatDir, tr ( "PDF files (*.pdf)" ) );
	}
	else{files = tmpList;}
	if ( !files.isEmpty() )
	{
		lastCatDir = QFileInfo ( files[0] ).absolutePath();
		int SIZE = files.count();int i;
		progd = new QProgressDialog ( tr ( "Adding files" ), tr ( "Cancel" ), 0, SIZE, this );
		progd->show();
		progd->setWindowModality ( Qt::WindowModal );
		//QApplication::setOverrideCursor ( QCursor ( Qt::WaitCursor ) );
		for ( i=0;i<SIZE;i++ )
		{
			progd->setValue ( i );
			if ( progd->wasCanceled() ) break;
			else
			{
				QProcess *getpage = new QProcess ( this );
				bool passcorr = true;
				bool changed;
				QString tmp_f = files[i];
				files[i] = checkPath ( "cat", files[i], "cat_cp", this, &changed, false );
				if ( files[i].isEmpty() ) {QMessageBox::critical ( this, tr ( "ERROR" ), tr ( "Failed to create temporary file<br>File %1<br>won't be added!" ) );}
				else
				{
					QString ss = pdftkBinC+" \""+files[i]+"\" dump_data output -";
					getpage->start ( ss );
					emit _addPEc ( ss );
					if ( !getpage->waitForStarted() ) {qDebug() <<"Could not start\n";}
					if ( !getpage->waitForFinished() ) {qDebug() <<"Could not finish\n";}
					getpage->closeWriteChannel();
					QString sNum = getpage->readAllStandardOutput();
					QString sErr = getpage->readAllStandardError();
					emit _addPE ( sNum+"<br>"+sErr );
					if ( !sErr.isEmpty() )
					{
						if ( sErr.contains ( "OWNER PASSWORD" ) )
						{
							bool cont = false;
							while ( !cont )
							{
								QMessageBox::warning ( this, tr ( "Attention" ), tr ( "Owner password required for<br>%1<br>No/incorrect password given!" ).arg ( tmp_f ) );
								if ( QMessageBox::question ( this, tr ( "Input password" ), tr ( "Do you want to input password?" ), QMessageBox::No | QMessageBox::Yes ) == QMessageBox::Yes )
								{
									QString paStr = QInputDialog::getText ( this, tr ( "Password" ), tr ( "Input password" ), QLineEdit::Password, "" );
									if ( paStr.isEmpty() ) {cont = true;passcorr = false;}
									else
									{
										ss = pdftkBinC+" \""+files[i]+"\" input_pw \""+paStr+"\" dump_data output -";
										getpage = new QProcess ( this );
										getpage->start ( ss );
										emit _addPEc ( ss );
										if ( !getpage->waitForStarted() ) {qDebug() <<"Could not start";}
										if ( !getpage->waitForFinished() ) {qDebug() <<"Could not finish";}
										getpage->closeWriteChannel();
										sErr = getpage->readAllStandardError();
										sNum = getpage->readAllStandardOutput();
										emit _addPE ( sNum+"<br>"+sErr );
										if ( !sErr.isEmpty() && sErr.contains ( "OWNER PASSWORD" ) ) {}
										if ( !sErr.isEmpty() && !sErr.contains ( "OWNER PASSWORD" ) ) {cont = true;passcorr = false;}
										if ( sErr.isEmpty() )
										{
											cont = true;passcorr = true;
											getpage = new QProcess ( this );
											QString procRUN = pdftkBinC+" \""+files[i]+"\" input_pw \""+paStr+"\" output \""+homeP+"/.suslictk/tmp_cat_num"+tr ( "%1" ).arg ( i ) +"_decrypted.pdf\"";
											getpage->start ( procRUN );
											emit _addPEc ( procRUN );
											getpage->waitForStarted();
											getpage->waitForFinished();
											emit _addPE ( getpage->readAllStandardOutput() +"<br>"+getpage->readAllStandardError() );
											if ( getpage->exitCode() == 0 ) {files[i] = homeP+"/.suslictk/tmp_cat_num"+tr ( "%1" ).arg ( i ) +"_decrypted.pdf";}
											else{passcorr = false;}
										}
									}
								}
								else{cont = true;passcorr = false;}
							}
						}
						else{passcorr = false;}
					}
					if ( passcorr )
					{
						if ( sNum.contains ( "NumberOfPages" ) )
						{
							QStringList qsl = sNum.split ( "\n" ).filter ( "NumberOfPages" );
							QString Num;
							Num = qsl.last().split ( " " ).last();
							PDFFiles<<files[i];
							FileList->addItem ( tmp_f );
							PageNum<<Num;
							PageIFRange<<"all";
							PageRange<<"none";
							PageSelect<<"none";
							PageRotation<<"none";
							PageQualifier<<"none";
						}
						else
						{
							QMessageBox::critical ( this, tr ( "Error" ), tr ( "Unable to get information about file<br> %1 <br>It will not be added!" ).arg ( files[i] ) );
						}
					}
				}
			}
		}
		progd->setValue ( SIZE );
		if ( i>0 )
		{
			OKB->setEnabled ( true );
			groupBox_7->setEnabled ( true );
		}
		//QApplication::restoreOverrideCursor();
		delete progd;
	}
}
void Cat::onAllCat()
{
	QString dir = QFileDialog::getExistingDirectory ( this, tr ( "Choose Directory" ), lastCatDir ,QFileDialog::ShowDirsOnly );
	if ( dir != NULL )
	{
		QDir DIR ( dir );
		tmpList.clear();
		tmpList = DIR.entryList ( QStringList() <<"*.pdf"<<"*.PDF", QDir::Files, QDir::Name );
		for ( int i=0;i<tmpList.count();i++ )
		{
			tmpList[i] = dir+"/"+tmpList[i];
		}
		onAdd ( false );
	}
}
void Cat::onUserEncrypt ( bool check )
{
	userEdit->setEnabled ( check );
	if ( check ) userEdit->setFocus();
	//else userEdit->setText("");
}
void Cat::onOwnerEncrypt ( bool check )
{
	ownerEdit->setEnabled ( check );
	if ( check ) ownerEdit->setFocus();
	//else ownerEdit->setText("");
}
/*void Cat::onPass ( QString str )
{
	PE = str;
}*/
void Cat::onSelectE ()
{
	if ( curRow>=0 && FileList->currentRow() == curRow )
	{
		QString tmp = QInputDialog::getText ( this, "", tr ( "Page range:" ), QLineEdit::Normal, PageSelect[curRow] );
		if ( !tmp.isEmpty() ) PageSelect[curRow] = tmp;
		else
		{
			all_radio->setChecked ( true );
			onAllR ( true );
		}
		qDebug() <<PageSelect[curRow];
	}
}
void Cat::onRangeE ()
{
	if ( curRow>=0 && FileList->currentRow() == curRow )
	{
		bool ok;
		int pages = PageNum[curRow].trimmed().toInt ( &ok );
		if ( !ok )
		{
			QMessageBox::critical ( this, tr ( "Number of pages" ), tr ( "Unable to convert string to int<br>You will have to input page range manually<br>When prompted, please insert page range in the following format: <b>\"from\"-\"to\"</b>(without quotes)<br>You can use \"end\" instead of last page number" ) );
			QString tt = QInputDialog::getText ( this, "", tr ( "Page range:" ), QLineEdit::Normal, "1-end" );
			if ( !tt.isEmpty() ) {PageRange[curRow] = tt;rangeEdit->setText ( tt );}
		}
		else
		{
			qDebug() <<backg;
			SelRange *sr = new SelRange ( this, Qt::SplashScreen, pages, backg );
			if ( sr->exec() == 1 )
			{
				if ( sr->from == sr->to )
				{
					qDebug() <<"sr->from="<<sr->from<<"\t"<<"sr->to="<<sr->to;
					select_radio->setChecked ( true );
					selectEdit->setEnabled ( true );
					rangeEdit->setEnabled ( false );
					PageIFRange[curRow] = "select";
					PageRange[curRow] = "none";
					selectEdit->setToolTip ( tr ( "%1" ).arg ( sr->from ) );
					PageSelect[curRow] = tr ( "%1" ).arg ( sr->from );
				}
				else
				{
					PageRange[curRow] = tr ( "%1-%2" ).arg ( sr->from ).arg ( sr->to );
					rangeEdit->setText ( tr ( "%1-%2" ).arg ( sr->from ).arg ( sr->to ) );
				}
			}
		}

	}
}
void Cat::onRemove()
{
	//bool iflast = ( curRow == FileList->count()-1 );
	qDebug() <<"curRow"<<curRow;
	if ( curRow>=0 && curRow<=FileList->count()-1 )
	{
		qDebug() <<"about to remove";
		FileList->takeItem ( curRow );
		qDebug() <<"Item removed";
		PDFFiles.removeAt ( curRow );
		PageRange.removeAt ( curRow );
		PageSelect.removeAt ( curRow );
		PageNum.removeAt ( curRow );
		PageRotation.removeAt ( curRow );
		PageQualifier.removeAt ( curRow );
		PageIFRange.removeAt ( curRow );
		qDebug() <<"all removed";
	}
	else return;
	if ( FileList->count() == 0 )
	{
		OKB->setEnabled ( false );
		groupBox_7->setEnabled ( false );
	}
	else
	{
		if ( curRow>=FileList->count() )
		{
			curRow = FileList->count()-1;
			FileList->setCurrentRow ( curRow );
			onList ( curRow );
		}
		if ( curRow<0 )
		{
			curRow = 0;
			FileList->setCurrentRow ( curRow );
			onList ( curRow );
		}
	}
}
void Cat::onOK()
{
	if ( label_3->isChecked() && label_4->isChecked() && userEdit->text() == ownerEdit->text() )
	{
		QMessageBox::warning ( this, "", tr ( "Error: The user and owner passwords are the same. PDF Viewers interpret this to mean your PDF has no owner password, so they must be different. Alternatively, supply no owner password to pdftk if this is what you desire." ) );
	}
	else
	{
		int num = PDFFiles.count();
		for ( int i=0;i<num;i++ )
		{
			PDFFiles[i] = "\""+PDFFiles[i]+"\"";
			PDFParams<<" cat ";
			if ( PageIFRange[i] == "all" )
			{
				PDFParams[i]+="1-end";
				if ( PageQualifier[i] == "odd" || PageQualifier[i] == "even" )
					PDFParams[i]+=PageQualifier[i];
				if ( PageRotation[i] != "none" )
					PDFParams[i]+=PageRotation[i];
			}
			if ( PageIFRange[i] == "range" )
			{
				PDFParams[i]+=PageRange[i];
				if ( PageQualifier[i] == "odd" || PageQualifier[i] == "even" )
					PDFParams[i]+=PageQualifier[i];
				if ( PageRotation[i] != "none" )
					PDFParams[i]+=PageRotation[i];
			}
			if ( PageIFRange[i] == "select" )
			{
				QStringList sList = PageSelect[i].split ( " ", QString::SkipEmptyParts );
				for ( int j=0;j<sList.count();j++ )
				{
					if ( sList[j].toInt() <= PageNum[i].toInt() && sList[j].toInt() > 0 )
					{
						if ( PageRotation[i] != "none" ) sList[j]+=PageRotation[i];
						PDFParams[i]+=sList[j]+" ";
					}
					else{qDebug() <<"sList["<<j<<"] = "<<sList[j] ;}
				}
			}
		}
		encr = "";
		if ( label_3->isChecked() && !userEdit->text().isEmpty() ) encr += " user_pw \""+userEdit->text() +"\" ";
		if ( label_4->isChecked() && !ownerEdit->text().isEmpty() ) encr += " owner_pw \""+ownerEdit->text() +"\" ";
		accept();
	}
}
QString Cat::getPE()
{
	QString str;
	if ( label_3->isChecked() && !userEdit->text().isEmpty() ) str+=tr ( "<b>user password: </b>%1;" ).arg ( userEdit->text() );
	if ( label_4->isChecked() && !ownerEdit->text().isEmpty() ) str+=tr ( "<b>owner password: </b>%1;" ).arg ( ownerEdit->text() );
	if ( str.isEmpty() ) str = tr ( "No encryption" );
	return str;
}
Cat::~Cat()
{
	destroy();
}
