/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HELPTK_H
#define HELPTK_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QDialog>
#include <QtGui/QHeaderView>
#include <QtGui/QPushButton>
#include <QtGui/QTextBrowser>
#include <QTextDocument>
#include <QInputDialog>
#include <QKeyEvent>
#include <QMessageBox>
#include <QtGui/QSpacerItem>
#include <QtGui/QVBoxLayout>
#include <QtGui/QHBoxLayout>

class HelpTk : public QDialog
{
		Q_OBJECT
	public:
		HelpTk ( QWidget* parent = 0, Qt::WindowFlags f = Qt::Dialog, QString str = "Coming soon...", QString focusAt = "" );
		~HelpTk();
	protected:
		void keyPressEvent ( QKeyEvent *event );
	private slots:
		void onClose();
		void onFind ( QString find = "" );
	private:
		void findNext();
		void retranslateUi();

		QHBoxLayout *horizontalLayout;
		QVBoxLayout *verticalLayout;
		QSpacerItem *verticalSpacer;
		QString findStr;
		QTextBrowser *textEdit;
		QPushButton *pushButton;
		QPushButton *findButton;
		QTextDocument *doc;
		QTextCursor cur;
};

#endif
