/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
bool ImportTheme ( QString file, QStringList* bPath )
{
	bPath->clear();
	QFile *tfile = new QFile ( file );
	if ( tfile->exists() )
	{
		if ( !tfile->open ( QFile::ReadOnly | QFile::Text ) )
		{
			QMessageBox::warning ( NULL, "PdfTk-QGUI", "Cannot open theme file" );
			return false;
		}
		else
		{
			QTextStream in ( tfile );
			QStringList imgs = in.readAll().split ( "\n", QString::SkipEmptyParts );
			*bPath<<imgs;
			tfile->close();
			return true;
		}
	}
	else{return false;}
	return true;
}
