/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PAGE_H
#define PAGE_H

#include <QtGui/QApplication>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QVBoxLayout>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QToolButton>
#include <QtGui/QCheckBox>
#include <QtGui/QSpacerItem>
#include <QtGui/QSpinBox>
#include <QDebug>

class Page: public QDialog
{
		Q_OBJECT
	public:
		Page ( QWidget *parent = 0, Qt::WindowFlags f = Qt::Dialog, int pages = -1,QString bg = "", int _from=1, int _to=1 );
		~Page();
		int pageF, pageT;
		bool odd, even;
		QString rotation;
	private slots:
		void onOK();
		void onUpF();
		void onDownF();
		void onUpT();
		void onDownT();
	private:
		QWidget *layoutWidget;
		QHBoxLayout *horizontalLayout;
		QPushButton *CAB;
		QPushButton *OKB;
		QWidget *widget, *widget1;
		QGridLayout *gridLayout;
		QLabel *label;
		QGridLayout *gridLayout_2;
		QSpinBox *fSpin;
		QToolButton *upfTool, *downfTool, *uptTool, *downtTool;
		QSpacerItem *horizontalSpacer;
		QLabel *label_2;
		QSpinBox *tSpin;
		QSpacerItem *horizontalSpacer_2;
		QSpacerItem *horizontalSpacer_3;
		QLabel *label_3;
		QComboBox *all_combo;
		QLabel *label_4;
		QHBoxLayout *horizontalLayout_4;
		QCheckBox *oddCheck;
		QCheckBox *evenCheck;
		QVBoxLayout *vboxLayout;
};

#endif
