/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PREVIEW_H
#define PREVIEW_H

#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QComboBox>
#include <QtGui/QDialog>
#include <QtGui/QGroupBox>
#include <QtGui/QHeaderView>
#include <QtGui/QLabel>
#include <QtGui/QLineEdit>
#include <QtGui/QProgressBar>
#include <QtGui/QPushButton>
#include <QtGui/QRadioButton>
#include <QtGui/QSpinBox>
#include <QtGui/QTabWidget>
#include <QtGui/QTextEdit>
#include <QRegExp>
#include <QDebug>

class Preview: public QDialog
{
		Q_OBJECT
	public:
		Preview ( QWidget *parent = 0, Qt::WindowFlags f = Qt::Dialog, QString stylesheet = "" );
		~Preview();
	private:
		QProgressBar *progressBar;
		QPushButton *pushButton;
		QGroupBox *groupBox;
		QRadioButton *radioButton;
		QCheckBox *checkBox;
		QLabel *label;
		QSpinBox *spinBox;
		QLabel *label_2;
		QGroupBox *groupBox_2;
		QTabWidget *tabWidget;
		QWidget *tab;
		QLineEdit *lineEdit;
		QComboBox *comboBox;
		QWidget *tab_2;
		QTextEdit *textEdit;
};

#endif
