/***************************************************************************
 *   Any complaints or wishes please mail to suslic-2012@rambler.ru        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "Select.h"

SDlg::SDlg ( QWidget* parent, Qt::WindowFlags f, QStringList *list, QString type1, QString lText )
{
	if ( parent != NULL ) {setParent ( parent );}
	if ( f != NULL ) {setWindowFlags ( f );}
	list_cp = list;type = type1;
	setObjectName ( QString::fromUtf8 ( "SDlg" ) );
	//resize ( 250, 300 );
	//widget = new QWidget ( this );
	//widget->setObjectName ( QString::fromUtf8 ( "widget" ) );
	//widget->setGeometry ( QRect ( 10, 20, 91, 111 ) );
	verticalLayout = new QVBoxLayout ( this );
	verticalLayout->setObjectName ( QString::fromUtf8 ( "verticalLayout" ) );
	//verticalLayout->setContentsMargins ( 0, 0, 0, 0 );
	label = new QLabel ( this );
	label->setObjectName ( QString::fromUtf8 ( "label" ) );

	verticalLayout->addWidget ( label );

	scrollArea = new QScrollArea ( this );
	scrollArea->setBaseSize ( 200, 100 );
	scrollArea->setObjectName ( QString::fromUtf8 ( "scrollArea" ) );
	scrollWidget = new QWidget ( this );
	scrollLayout = new QVBoxLayout ( scrollWidget );
	scrollLayout->setObjectName ( QString::fromUtf8 ( "scrollLayout" ) );
	//scrollLayout->setContentsMargins ( 0, 0, 0, 0 );

	//qDebug() <<"created scrollLayout";

	if ( type == "check" )
	{
		checkBoxes = new QCheckBox*[list_cp->count() ];
		for ( int i=0;i<list_cp->count();i++ )
		{
			checkBoxes[i] = new QCheckBox ( scrollWidget );
			checkBoxes[i]->setObjectName ( tr ( "checkBox%1" ).arg ( i ) );
			checkBoxes[i]->setText ( list_cp->at ( i ) );
			scrollLayout->addWidget ( checkBoxes[i] );
		}
		//qDebug()<<"created checkBoxes";

		scrollArea->setWidget(scrollWidget);
		verticalLayout->addWidget ( scrollArea );

		layoutWidget2 = new QWidget ( this );
		layoutWidget2->setObjectName ( QString::fromUtf8 ( "layoutWidget2" ) );
		horizontalLayout2 = new QHBoxLayout ( layoutWidget2 );
		horizontalLayout2->setObjectName ( QString::fromUtf8 ( "horizontalLayout2" ) );

		horizontalSpacer_2 = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );

		allB = new QPushButton ( layoutWidget2 );
		allB->setObjectName ( QString::fromUtf8 ( "allB" ) );
		connect ( allB, SIGNAL ( clicked() ), this, SLOT ( onAll() ) );

		horizontalLayout2->addWidget ( allB );

		horizontalLayout2->addItem(horizontalSpacer_2);

		//qDebug() <<"created allB";

		noneB = new QPushButton ( layoutWidget2 );
		noneB->setObjectName ( QString::fromUtf8 ( "noneB" ) );
		connect ( noneB, SIGNAL ( clicked() ), this, SLOT ( onNone() ) );

		horizontalLayout2->addWidget ( noneB );

		//qDebug() <<"created noneB";
	}
	if ( type == "radio" )
	{
		radioButtons = new QRadioButton*[list_cp->count() ];
		for ( int i=0;i<list_cp->count();i++ )
		{
			radioButtons[i] = new QRadioButton ( scrollWidget );
			radioButtons[i]->setObjectName ( tr ( "radioButton%1" ).arg ( i ) );
			radioButtons[i]->setText ( list_cp->at ( i ) );
			scrollLayout->addWidget ( radioButtons[i] );
		}

		scrollArea->setWidget(scrollWidget);
		verticalLayout->addWidget ( scrollArea );

	}

	layoutWidget = new QWidget ( this );
	layoutWidget->setObjectName ( QString::fromUtf8 ( "layoutWidget" ) );
	//layoutWidget->setGeometry ( QRect ( 80, 260, 162, 31 ) );
	horizontalLayout = new QHBoxLayout ( layoutWidget );
	horizontalLayout->setObjectName ( QString::fromUtf8 ( "horizontalLayout" ) );

	horizontalSpacer = new QSpacerItem ( 40, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
	horizontalLayout->addItem(horizontalSpacer);

	CAB = new QPushButton ( layoutWidget );
	CAB->setObjectName ( QString::fromUtf8 ( "CAB" ) );

	horizontalLayout->addWidget ( CAB );

	OKB = new QPushButton ( layoutWidget );
	OKB->setObjectName ( QString::fromUtf8 ( "OKB" ) );

	horizontalLayout->addWidget ( OKB );

	if ( type == "check" )	verticalLayout->addWidget ( layoutWidget2 );
	verticalLayout->addWidget ( layoutWidget );
	adjustSize();

	connect ( CAB, SIGNAL ( clicked() ), this, SLOT ( reject() ) );
	connect ( OKB, SIGNAL ( clicked() ), this, SLOT ( onOk() ) );

	label->setText ( lText );
	retranslateUi();

	adjustSize();
};
void SDlg::retranslateUi()
{
	setWindowTitle ( QApplication::translate ( "SDlg", "SDlg", 0, QApplication::UnicodeUTF8 ) );
	CAB->setText ( QApplication::translate ( "SDlg", "Cancel", 0, QApplication::UnicodeUTF8 ) );
	OKB->setText ( QApplication::translate ( "SDlg", "OK", 0, QApplication::UnicodeUTF8 ) );
	if ( type == "check" )
	{
		allB->setText ( QApplication::translate ( "SDlg", "&Select all", 0, QApplication::UnicodeUTF8 ) );
		noneB->setText ( QApplication::translate ( "SDlg", "&Deselect all", 0, QApplication::UnicodeUTF8 ) );
	}
}
void SDlg::onAll()
{
	for ( int i=0;i<list_cp->count();i++ )
	{
		checkBoxes[i]->setChecked ( true );
	}
}
void SDlg::onNone()
{
	for ( int i=0;i<list_cp->count();i++ )
	{
		checkBoxes[i]->setChecked ( false );
	}
}
void SDlg::onOk()
{
	if ( type == "check" )
	{
		QStringList tmpList;
		for ( int i = 0;i<list_cp->count();i++ )
		{

			if ( checkBoxes[i]->isChecked() )
			{
				tmpList<<list_cp->at ( i );
			}
		}
		list_cp->clear();*list_cp<<tmpList;
	}
	if ( type == "radio" )
	{
		for ( int i =0;i<list_cp->count();i++ )
		{

			if ( radioButtons[i]->isChecked() )
			{
				QString tmp = list_cp->at ( i );
				list_cp->clear();
				*list_cp<<tmp;break;
			}
		}
	}

	accept();
}
SDlg::~SDlg()
{
	destroy();
}
